#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"
//#include "AppRsc.h"
#ifdef __PACE__
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif


#include "PNOMain.h"

#include "pnobridge.h"


#include "unzip.h"

UInt32 mStopEmulation=0;

char gpstr[256]; //used for general debugging purpose
char pak_dir[256];

unsigned int g_confinput[20];

extern UInt32 device_type;
extern UInt32 g_rotated;
UInt16 *zodvram;

extern int SCREENWIDTH;
extern int SCREENHEIGHT;

extern UInt32 bNetLibOpened;
extern UInt32 gblIPAddress;
extern UInt32 netLibRefNum;
extern UInt32 gblQuakePort;

extern UInt32 n2PlayerRole;
extern UInt32 nSerPortId;
extern UInt32 bSerPortOpened;

char username[16];

UInt32 bDebugFile = 0;
UInt32 bMute = 0;
UInt32 bTreo600SDK = 0;
UInt32 bTreo650SDK = 0;

void ClearScreen(void);
void Sys_PrintF( char *s, ...);

unsigned long Run()
{
	UInt32 max, bytes;
	UInt32 result,penDown;
	char *ftrptr;
	
	YDK_HANDLE_EVENT_NOFUNC()
	
	device_type = (UInt32)(g_pnobridge -> flags) & (UInt32)(BF_ZODIAC|BF_HIRESPLUS);
	
	if (device_type & BF_ZODIAC) {	
		zodvram=(UInt16*) stubzodiacblit ( 0,0,0,0 );
		if (!zodvram) menu_info("Zodiac VRAM NULL ptr!!");
	}
	
	FtrGet(CREATORID, FTR_VIDEO_ROT_ID, (unsigned long*)&g_rotated);
	FtrGet(CREATORID, FTR_MUTE_ID, (unsigned long*)&bMute);
	FtrGet(CREATORID, FTR_VIDEO_RESX_ID, (unsigned long*)&SCREENWIDTH);
	FtrGet(CREATORID, FTR_VIDEO_RESY_ID, (unsigned long*)&SCREENHEIGHT);

	FtrGet(CREATORID, FTR_TREO_600_ID, (unsigned long*)&bTreo600SDK);
	FtrGet(CREATORID, FTR_TREO_650_ID, (unsigned long*)&bTreo650SDK);

	FtrGet(CREATORID, FTR_SER_ROLE_ID, (unsigned long*)&n2PlayerRole);
	FtrGet(CREATORID, FTR_SER_PORT_ID, (unsigned long*)&nSerPortId);
	FtrGet(CREATORID, FTR_SER_OPEN_ID, (unsigned long*)&bSerPortOpened);

	FtrGet(CREATORID, FTR_NET_OPEN_ID, (unsigned long*)&bNetLibOpened);
	FtrGet(CREATORID, FTR_NET_IP_ID, (unsigned long*)&gblIPAddress);
	FtrGet(CREATORID, FTR_NET_LIB_ID, (unsigned long*)&netLibRefNum);
	FtrGet(CREATORID, FTR_NET_PORT_ID, (unsigned long*)&gblQuakePort);

	FtrGet(CREATORID, FTR_DEBUGFILE_ID, (unsigned long*)&bDebugFile);

    FtrGet(CREATORID, FTR_PAK_DIR_ID, (unsigned long*)&ftrptr);
    strcpy(pak_dir, ftrptr);
    FtrPtrFree(CREATORID, FTR_PAK_DIR_ID);
    
    FtrGet(CREATORID, FTR_NET_USER_ID, (unsigned long*)&ftrptr);
    strncpy(username, ftrptr, sizeof(username));
    username[sizeof(username) - 1] = 0;
    FtrPtrFree(CREATORID, FTR_NET_USER_ID);
    
    FtrGet(CREATORID, FTR_OPT_INPUTCONF_ID, (unsigned long*)&ftrptr);
	for (int i=0;i<20;i++) g_confinput[i]=ByteSwap32(((UInt32*)ftrptr)[i]);
    FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
	
   	GpMain ( NULL );
   	
   	if (device_type & BF_ZODIAC) {
		stubzodiacblit ( 1,0,0,0 );
	}
   	
	return 0;
}


/************************************/

void ClearScreen(void)
{
	UInt8 *vr;
	vr=(UInt8*)(g_pnobridge -> vram);
	for (int y=0;y<g_pnobridge -> display_height;y++)
	{
		memset(vr,0,g_pnobridge -> display_width*2);
		vr+=(g_pnobridge -> display_pitch)*2;
	}
}

void GpError ( char *s, ... ){
//	menu_info(s);
}

/*
 * The following functions provide hooks for stdin/stdout/stderr.
 * Applications may override them to do whatever they want. The
 * default implementation redirects console IO through ARM semihosting
 * interface.
 */
 
/*typedef unsigned long	__file_handle;
typedef void * __ref_con;
enum __io_results 
{
     __no_io_error,
     __io_error,
     __io_EOF         							
};

int
__close_console(__file_handle file)
{
    return __no_io_error;
}

int
__read_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __io_EOF;
}

int
__write_console(__file_handle file, unsigned char * buff, size_t * count, __ref_con ref_con)
{
    return __no_io_error;
}
*/

void Sys_PrintF( char *s, ...){
	va_list		argptr;
	char		text[1024];

	va_start (argptr,s);
	vsprintf (text, s, argptr);
	va_end (argptr);

//	menu_messageL(text);	
//	menu_waitPen(NULL,NULL,1);	
	menu_button(5,5,text,0,NULL,4);	
}
