/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

//
// GP32 video driver by Anders Granlund
//
// Based on:
//
//Pocket PC Video Driver
//Dan East - Jan 20, 2001
//pocketquake@pocketmatrix.com
//www.pocketmatrix.com/pocketmatrix

#include "quakedef.h"
#include "winquake.h"
#include "d_local.h"

#include "pnobridge.h"

#include "vid_palmmode.h"

//#define	BASEWIDTH	320
//#define	BASEHEIGHT	240
//YOYOFR
#define	BASEWIDTH	480
#define	BASEHEIGHT	320

int current_witdh=320;
int current_height=240;

//TwGfxSurfaceType *g_backbuffer_surface;
UInt8 *g_backbuffer;
UInt32 g_backbuffer_pitch;
extern UInt32 device_type;
extern UInt16 *zodvram;
UInt32 g_rotated;
//
int min_vid_width=320;

extern volatile pnobridge_t *g_pnobridge;


//vars for mlook

int vid_init=0;

__int64 FPM_TMPVAR_INT64;

extern int SCREENWIDTH;
extern int SCREENHEIGHT;
extern int boolKeyboard;
extern int nShowScreenButtons;
#define KEY_WIDTH 25
#define KEY_HEIGHT 25

#define myWinPaintRectangleFrame(r, d) \
           WinDrawLine(r.topLeft.x + d, r.topLeft.y, r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y); \
           WinDrawLine(r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y, r.topLeft.x + r.extent.x - 1, r.topLeft.y + d); \
           WinDrawLine(r.topLeft.x + r.extent.x - 1, r.topLeft.y + d, r.topLeft.x + r.extent.x - 1, r.topLeft.y + r.extent.y - 1 - d); \
           WinDrawLine(r.topLeft.x + r.extent.x - 1, r.topLeft.y + r.extent.y - 1 - d, r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y + r.extent.y - 1); \
           WinDrawLine(r.topLeft.x + d, r.topLeft.y + r.extent.y - 1, r.topLeft.x + r.extent.x - 1 - d, r.topLeft.y + r.extent.y - 1); \
           WinDrawLine(r.topLeft.x + d, r.topLeft.y + r.extent.y - 1, r.topLeft.x, r.topLeft.y + r.extent.y - 1 - d); \
           WinDrawLine(r.topLeft.x, r.topLeft.y + d, r.topLeft.x, r.topLeft.y + r.extent.y - 1 - d); \
           WinDrawLine(r.topLeft.x, r.topLeft.y + d, r.topLeft.x + d, r.topLeft.y);

extern viddef_t	vid;				// global video state

uint32	dummy_for_align1=0;
pixel_t	vid_buffer[BASEWIDTH*BASEHEIGHT];
short		zbuffer[BASEWIDTH*BASEHEIGHT];
unsigned char	surfcache[256*1024];
unsigned short	d_8to16table[256];
//unsigned	d_8to24table[256];
float start_yaw;
float yaw_modifier;

unsigned short int gpPalette [ 256 ];

// 320x240, 240x160, 480x320
// 0          1          2
cvar_t		vid_mode = {"vid_mode","0",false};
int vid_modenum;
int numvidmodes; 

typedef struct
{
	int		modenum;
	char	*desc;
	int		iscur;
} modedesc_t;

vmode_t	*pvidmodes;

#define MAX_COLUMN_SIZE	3

#define MAX_MODEDESCS	(MAX_COLUMN_SIZE*3)

static modedesc_t	modedescs[MAX_MODEDESCS];

#define NUMVIDMODES	3//	(sizeof(palmmodes) / sizeof(palmmodes[0]))


void VID_NumModes_f (void);
void VID_DescribeCurrentMode_f (void);
void VID_DescribeMode_f (void);
void VID_DescribeModes_f (void);
void VID_MenuDraw (void);
void VID_MenuKey (int key);
char *VID_ModeInfo (int modenum, char **ppheader);
vmode_t *VID_GetModePtr (int modenum);

static int	vid_line, vid_wmodes, vid_column_size;
/*
================
ClearAllStates
================
*/
void ClearAllStates()
{
	int		i;
	// send an up event for each key, to make sure the server clears them all
	for (i=0 ; i<256 ; i++)
	{
		Key_Event (i, false);
	}
	Key_ClearStates ();
	IN_ClearStates ();
}

/*
================
VID_LockBuffer
================
*/
/*void VID_LockBuffer()
{
}
*/

/*
================
VID_UnlockBuffer
================
*/
/*void VID_UnlockBuffer()
{
}
*/


/*
================
VID_SetPalette
================
*/
void VID_SetPalette (unsigned char *palette)
{
	int i;
	unsigned short r,g,b;
	for (i = 0; i < 256; i++) {
	  r = (palette[i * 3 + 0] >> 3);// if(r>0x1F) r=0x1F;
	  g = (palette[i * 3 + 1] >> 2);// if(g>0x1F) g=0x1F;
	  b = (palette[i * 3 + 2] >> 3);// if(b>0x1F) b=0x1F;

	  gpPalette[i] = ( (r<<11) | (g<<5) | (b) );
	}

	//gpPalCur = GpPaletteCreate(256, gpPalette);
	//GpPaletteSelect(gpPalCur);
	//GpPaletteRealize();
}

/*
================
VID_ShiftPalette
================
*/
void VID_ShiftPalette (unsigned char *palette)
{
	int i;
	unsigned short r,g,b;
	for (i = 0; i < 256; i++) {
	  r = (palette[i * 3 + 0] >> 3);// if(r>0x1F) r=0x1F;
	  g = (palette[i * 3 + 1] >> 2);// if(g>0x1F) g=0x1F;
	  b = (palette[i * 3 + 2] >> 3);// if(b>0x1F) b=0x1F;

	  gpPalette[i] = ( (r<<11) | (g<<5) | (b) );
	}
}


/*
================
VID_NumModes
================
*/
int VID_NumModes ()
{
	return (numvidmodes);
}

void PALMVideoMode_Init (void)
{
	int		i;

// link together all the VGA modes
	for (i=0 ; i<(NUMVIDMODES - 1) ; i++)
	{
		palmmodes[i].pnext = &palmmodes[i+1];
	}

// add the VGA modes at the start of the mode list
	palmmodes[NUMVIDMODES-1].pnext = pvidmodes;
	pvidmodes = &palmmodes[0];

	numvidmodes += NUMVIDMODES;
}

/*
================
VID_SetMode
================
*/
int VID_SetMode (int modenum, unsigned char *palette)
{
	vmode_t	*pnewmode;
	
	vid_modenum=modenum;	
	pnewmode = VID_GetModePtr (modenum);
	
	Cvar_SetValue ("vid_mode", (float)vid_modenum);
	
	current_witdh=pnewmode->width;
	current_height=pnewmode->height;
	min_vid_width=pnewmode->width;	
	vid.aspect = pnewmode->aspect;
	
	vid.maxwarpwidth = vid.width = vid.conwidth = current_witdh;
	vid.maxwarpheight = vid.height = vid.conheight = current_height;
	vid.rowbytes = vid.conrowbytes = current_witdh;
		
	vid.recalc_refdef = 1;
	
	ClearScreen();
}


/*
================
VID_Init
================
*/

void VID_Init (unsigned char *palette)
{
	numvidmodes=0;
	pvidmodes=NULL;
	PALMVideoMode_Init();

	Cvar_RegisterVariable (&vid_mode);
	
	Cmd_AddCommand ("vid_nummodes", VID_NumModes_f);
	Cmd_AddCommand ("vid_describecurrentmode", VID_DescribeCurrentMode_f);
	Cmd_AddCommand ("vid_describemode", VID_DescribeMode_f);
	Cmd_AddCommand ("vid_describemodes", VID_DescribeModes_f);
	
	
	VID_SetMode(vid_mode.value,NULL);
	
	
	vid.aspect = 1.0;
	vid.numpages = 1;
	vid.colormap = (pixel_t*)host_colormap;
	vid.fullbright = 256 - LittleLong (*((int *)vid.colormap + 2048));
	vid.buffer = vid.conbuffer = vid_buffer;
	

	d_pzbuffer = zbuffer;
	D_InitCaches (surfcache, sizeof(surfcache));

	VID_SetPalette(palette);

	//Sound initialization
	//S_Init ();
	Draw_Init();

	vid_init = 1;
	
	//YOYOFR Zod
	{
		if (device_type & BF_ZODIAC) g_backbuffer=(uint8*)zodvram;
	    else g_backbuffer=(uint8*)(g_pnobridge->vram);
	    g_backbuffer_pitch=(g_pnobridge->display_pitch)*2;
	}
	
	
	vid_menudrawfn = VID_MenuDraw;
	vid_menukeyfn = VID_MenuKey;
	vid_modenum = vid_mode.value;
		
}


/*
================
VID_Shutdown
================
*/
void VID_Shutdown()
{
//YOYOFR	
  // free backbuffer
//  TwGfxUnlockSurface(g_backbuffer_surface,true);
//  TwGfxFreeSurface ( g_backbuffer_surface );
//
}


void zq_asmfastrender320(UInt8 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
void zq_asmfastrender320r(UInt8 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
void zq_asmfastrender240(UInt8 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
void zq_asmfastrender240r(UInt8 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
void zq_asmfastrender480(UInt8 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
void zq_asmfastrender480r(UInt8 *dst,UInt8 *src,UInt16 *pal,UInt32 pitch,UInt32 h);
/*
================
VID_Update
================
*/
void VID_Update(vrect_t *rects)
{
//YOYOFR
  unsigned short int *g_shownbuffer = NULL;
 //

	int x,y;
	UInt16 *pos;
	pixel_t *vid1;

	int xx,yy;
	int ww,hh;



	xx = rects->x;
	yy = rects->y;
	ww = rects->width;
	hh = rects->height;
	

	//pos  = g_backbuffer + xx + ( (UInt32)yy * (UInt32)480 );
	//vid1 = (char *) vid.buffer + xx + ((UInt32)yy*(UInt32)320);
	if (ww==240) {
		if (g_rotated) zq_asmfastrender240r((UInt8*)g_backbuffer,(UInt8*)vid.buffer,(UInt16*)gpPalette,g_backbuffer_pitch,hh);
		else zq_asmfastrender240((UInt8*)g_backbuffer,(UInt8*)vid.buffer,(UInt16*)gpPalette,g_backbuffer_pitch,hh);
		if (device_type & BF_ZODIAC) stubzodiacblit(3,240,160,5);
	}
	if (ww==320) {
		if (g_rotated) zq_asmfastrender320r((UInt8*)g_backbuffer,(UInt8*)vid.buffer,(UInt16*)gpPalette,g_backbuffer_pitch,hh);
		else zq_asmfastrender320((UInt8*)g_backbuffer,(UInt8*)vid.buffer,(UInt16*)gpPalette,g_backbuffer_pitch,hh);
		if (device_type & BF_ZODIAC) stubzodiacblit(3,320,240,5);
	}
    if (ww==480) {
/*    	if (device_type & BF_ZODIAC) zq_asmfastrender480((UInt8*)zodvram,(UInt8*)vid.buffer,(UInt16*)gpPalette,g_backbuffer_pitch,hh);
    	else*/ 
    	if (g_rotated) zq_asmfastrender480r((UInt8*)(g_pnobridge->vram),(UInt8*)vid.buffer,(UInt16*)gpPalette,g_backbuffer_pitch,hh);
    	else zq_asmfastrender480((UInt8*)(g_pnobridge->vram),(UInt8*)vid.buffer,(UInt16*)gpPalette,g_backbuffer_pitch,hh);
    }
    
/*	if (ww<480) {
	  TwGfxRectType rect;   // source
	  TwGfxRectType drect;  // destination
	  	  	  
	  rect.x = 0;
	  rect.y = 0;
	  rect.w = current_witdh;//BASEWIDTH;
	  rect.h = current_height;//BASEHEIGHT;
	  drect.x = 0; 
	  drect.y = 0;
	  drect.w = 480;//ginfo.displayWidth;
	  drect.h = 320;//ginfo.displayHeight;
	  
	  TwGfxStretchBlt2 ( GameApp.displaySurface, &drect,
		     g_backbuffer_surface, &rect,
		     twGfxStretchFast | twGfxStretchSmooth );
	}
	else{
	  TwGfxRectType rect;   // source
	  TwGfxPointType dpoint;  // destination
	  	  	  
	  rect.x = 0;
	  rect.y = 0;
	  rect.w = current_witdh;//BASEWIDTH;
	  rect.h = current_height;//BASEHEIGHT;
	  dpoint.x = 0; 
	  dpoint.y = 0;
	  
	  TwGfxAsyncBlt ( GameApp.displaySurface, &dpoint,
		     g_backbuffer_surface, &rect  );
	}
	//
*/

	if (nShowScreenButtons > 0)
	{
		RGBColorType fg;	
		RectangleType rect;	
		char *p;
		int x, y;
	
		WinPushDrawState();
		WinSetCoordinateSystem(kCoordinatesNative);

		WinSetDrawMode(winOverlay);

	    fg.r = 220; fg.g = 180; fg.b = 40;
    	WinSetForeColorRGB(&fg, NULL);

		rect.topLeft.x = SCREENWIDTH/*display_width*/-80;
		rect.topLeft.y = 0;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = SCREENWIDTH/*display_width*/-80;
		rect.topLeft.y = (SCREENHEIGHT/*display_height*/>>1)-30;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = SCREENWIDTH/*display_width*/-80;
		rect.topLeft.y = SCREENHEIGHT/*display_height*/-60;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = 0;
		rect.topLeft.y = 0;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = 0;
		rect.topLeft.y = (SCREENHEIGHT/*display_height*/>>1)-30;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = 0;
		rect.topLeft.y = SCREENHEIGHT/*display_height*/-60;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = (SCREENWIDTH/*display_width*/>>1)-40;
		rect.topLeft.y = 0;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = (SCREENWIDTH/*display_width*/>>1)-40;
		rect.topLeft.y = (SCREENHEIGHT/*display_height*/>>1)-30;
		rect.extent.x = 80;
		rect.extent.y = 28;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = (SCREENWIDTH/*display_width*/>>1)-40;
		rect.topLeft.y = (SCREENHEIGHT/*display_height*/>>1);
		rect.extent.x = 80;
		rect.extent.y = 28;
		myWinPaintRectangleFrame(rect, 5);

		rect.topLeft.x = (SCREENWIDTH/*display_width*/>>1)-40;
		rect.topLeft.y = SCREENHEIGHT/*display_height*/-60;
		rect.extent.x = 80;
		rect.extent.y = 60;
		myWinPaintRectangleFrame(rect, 5);

		WinPopDrawState();

		nShowScreenButtons--;
	}

	if (boolKeyboard)
	{
		RGBColorType fg;	
		RectangleType rect;	
		char *p;
		int x, y;
	
		WinPushDrawState();
		WinSetCoordinateSystem(kCoordinatesNative);

		WinSetDrawMode(winOverlay);
//		WinSetDrawMode(winPaint);
		FntSetFont(stdFont);

	    fg.r = 110; fg.g = 90; fg.b = 20;
    	WinSetForeColorRGB(&fg, NULL);
	    fg.r = 220; fg.g = 180; fg.b = 40;
		WinSetTextColorRGB(&fg, NULL);
    	for (y = 0; y < 5; y++)
    	{
			rect.topLeft.y = (SCREENHEIGHT/*display_height*/ - (5 * KEY_HEIGHT) - (KEY_HEIGHT / 2)) + (y * KEY_HEIGHT);
			if (y == 0)
			{
				const char *chrs[11] = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "<"};
				for (x = 0; x < 11; x++)
				{
					rect.topLeft.x = (x * KEY_WIDTH);
					rect.extent.x = KEY_WIDTH - 2;
					rect.extent.y = KEY_HEIGHT - 2;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
			}
			else if (y == 1)
			{
				const char *chrs[11] = {"Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "~"};
				for (x = 0; x < 11; x++)
				{
					rect.topLeft.x = (KEY_WIDTH / 2) + (x * KEY_WIDTH);
					rect.extent.x = KEY_WIDTH - 2;
					rect.extent.y = KEY_HEIGHT - 2;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
			}
			else if (y == 2)
			{
				const char *chrs[9] = {"A", "S", "D", "F", "G", "H", "J", "K", "L"};
				for (x = 0; x < 9; x++)
				{
					rect.topLeft.x = KEY_WIDTH + (x * KEY_WIDTH);
					rect.extent.x = KEY_WIDTH - 2;
					rect.extent.y = KEY_HEIGHT - 2;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
				/* return */
				rect.topLeft.x = KEY_WIDTH + (9 * KEY_WIDTH);
				rect.extent.x = (2 * KEY_WIDTH) - 2;
				rect.extent.y = KEY_HEIGHT - 2;
				myWinPaintRectangleFrame(rect, 5);
				WinPaintChars("Ret", 3, rect.topLeft.x + ((rect.extent.x - FntCharsWidth("Ret", 3)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
			}
			else if (y == 3)
			{
				const char *chrs[9] = {"Z", "X", "C", "V", "B", "N", "M", "-", "."};
				for (x = 0; x < 9; x++)
				{
					rect.topLeft.x = KEY_WIDTH + (KEY_WIDTH / 2) + (x * KEY_WIDTH);
					rect.extent.x = KEY_WIDTH - 2;
					rect.extent.y = KEY_HEIGHT - 2;
					myWinPaintRectangleFrame(rect, 5);
					WinPaintChars(chrs[x], 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth(chrs[x], 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
				}
			}
			else if (y == 4)
			{
				/* space */
				rect.topLeft.x = (2 * KEY_WIDTH);
				rect.extent.x = (6 * KEY_WIDTH) - 2;
				rect.extent.y = KEY_HEIGHT - 2;
				myWinPaintRectangleFrame(rect, 5);
				WinPaintChars("Space", 5, rect.topLeft.x + ((rect.extent.x - FntCharsWidth("Space", 5)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);

				/* close */
				rect.topLeft.x = (2 * KEY_WIDTH) + (6 * KEY_WIDTH);
				rect.extent.x = (2 * KEY_WIDTH) - 2;
				rect.extent.y = KEY_HEIGHT - 2;
				myWinPaintRectangleFrame(rect, 5);
				WinPaintChars("", 1, rect.topLeft.x + ((rect.extent.x - FntCharsWidth("", 1)) / 2), rect.topLeft.y + (((KEY_HEIGHT- 2) - FntCharHeight()) / 2)/* - (FntCharHeight() / 2)*/);
			}
		}

		WinPopDrawState();
	}
}




/*
================
D_BeginDirectRect
================
*/
void D_BeginDirectRect (int x, int y, byte *pbitmap, int width, int height)
{
}


/*
================
D_EndDirectRect
================
*/
void D_EndDirectRect (int x, int y, int width, int height)
{
}





















/*
================
VID_HandlePause
================
*/
void VID_HandlePause (qboolean pause)
{
}



void DeinitConProc (void);


/*
=================
VID_GetModePtr
=================
*/
vmode_t *VID_GetModePtr (int modenum)
{
	vmode_t	*pv;

	pv = pvidmodes;
	if (!pv)
		Sys_Error ("VID_GetModePtr: empty vid mode list");

	while (modenum--)
	{
		pv = pv->pnext;
		if (!pv)
			Sys_Error ("VID_GetModePtr: corrupt vid mode list");
	}

	return pv;
}


/*
=================
VID_NumModes_f
=================
*/
void VID_NumModes_f (void)
{
	int		nummodes;

	nummodes = VID_NumModes ();
	if (nummodes == 1)
		Con_Printf ("%d video mode is available\n", VID_NumModes ());
	else
		Con_Printf ("%d video modes are available\n", VID_NumModes ());
}


/*
=================
VID_DescribeCurrentMode_f
=================
*/
void VID_DescribeCurrentMode_f (void)
{
	Con_Printf ("%s\n", VID_ModeInfo (vid_modenum, NULL));
}


/*
=================
VID_DescribeMode_f
=================
*/
void VID_DescribeMode_f (void)
{
	int		modenum;
	
	modenum = Q_atoi (Cmd_Argv(1));

	Con_Printf ("%s\n", VID_ModeInfo (modenum, NULL));
}


/*
=================
VID_DescribeModes_f
=================
*/
void VID_DescribeModes_f (void)
{
	int			i, nummodes;
	char		*pinfo, *pheader;
	vmode_t		*pv;
	qboolean	na;

	na = false;

	nummodes = VID_NumModes ();
	for (i=0 ; i<nummodes ; i++)
	{
		pv = VID_GetModePtr (i);
		pinfo = VID_ModeInfo (i, &pheader);
		if (pheader)
			Con_Printf ("\n%s\n", pheader);

/*		if (VGA_CheckAdequateMem (pv->width, pv->height, pv->rowbytes,
			(pv->numpages == 1) || vid_nopageflip.value))*/
		{
			Con_Printf ("%2d: %s\n", i, pinfo);
		}
/*		else
		{
			Con_Printf ("**: %s\n", pinfo);
			na = true;
		}*/
	}

/*	if (na)
	{
		Con_Printf ("\n[**: not enough system RAM for mode]\n");
	}*/
}


/*
=================
VID_GetModeDescription
=================
*/
char *VID_GetModeDescription (int mode)
{
	char		*pinfo, *pheader;
	vmode_t		*pv;

	pv = VID_GetModePtr (mode);
	pinfo = VID_ModeInfo (mode, &pheader);

/*	if (VGA_CheckAdequateMem (pv->width, pv->height, pv->rowbytes,
		(pv->numpages == 1) || vid_nopageflip.value))*/
	{
		return pinfo;
	}
/*	else
	{
		return NULL;
	}*/
}






/*
================
VID_MenuDraw
================
*/
void VID_MenuDraw (void)
{
	qpic_t		*p;
	char		*ptr;
	int			nummodes, i, j, column, row, dup;
	char		*temp;

	vid_wmodes = 0;
	nummodes = VID_NumModes ();
	
	p = Draw_CachePic ("gfx/vidmodes.lmp");
	M_DrawPic ( (320-p->width)/2, 4, p);

	for (i=0 ; i<nummodes ; i++)
	{
		if (vid_wmodes < MAX_MODEDESCS)
		{
//			if (i != 1)
			{
				ptr = VID_GetModeDescription (i);

				if (ptr)
				{
					dup = 0;

					for (j=0 ; j<vid_wmodes ; j++)
					{
						if (!strcmp (modedescs[j].desc, ptr))
						{
							if (modedescs[j].modenum != 0)
							{
								modedescs[j].modenum = i;
								dup = 1;

								if (i == vid_modenum)
									modedescs[j].iscur = 1;
							}
							else
							{
								dup = 1;
							}

							break;
						}
					}

					if (!dup)
					{
						modedescs[vid_wmodes].modenum = i;
						modedescs[vid_wmodes].desc = ptr;
						modedescs[vid_wmodes].iscur = 0;

						if (i == vid_modenum)
							modedescs[vid_wmodes].iscur = 1;

						vid_wmodes++;
					}
				}
			}
		}
	}

	vid_column_size = (vid_wmodes + 2) / 3;

	column = 16;
	row = 36;

	for (i=0 ; i<vid_wmodes ; i++)
	{
		if (modedescs[i].iscur)
			M_PrintWhite (column, row, modedescs[i].desc);
		else
			M_Print (column, row, modedescs[i].desc);

		row += 8;

		if ((i % vid_column_size) == (vid_column_size - 1))
		{
			column += 9*8;
			row = 36;
		}
	}

// line cursor
	{
		VID_ModeInfo(vid_line,&temp);
	
		M_Print (3*8, 36 + MAX_COLUMN_SIZE * 8 + 8,
				"Press Enter to set mode");
		M_Print (2*8, 36 + MAX_COLUMN_SIZE * 8 + 8*4, temp);

		M_Print (9*8, 36 + MAX_COLUMN_SIZE * 8 + 8*7,
				"Esc to exit");

		row = 36 + (vid_line % vid_column_size) * 8;
		column = 8 + (vid_line / vid_column_size) * 9*8;

		M_DrawCharacter (column, row, 12+((int)(realtime*4)&1));
	}
}


/*
================
VID_MenuKey
================
*/
void VID_MenuKey (int key)
{


	switch (key)
	{
	case K_ESCAPE:
		S_LocalSound ("misc/menu1.wav");
		M_Menu_Options_f ();
		break;

	case K_UPARROW:
		S_LocalSound ("misc/menu1.wav");
		vid_line--;

		if (vid_line < 0)
			vid_line = vid_wmodes - 1;
		break;

	case K_DOWNARROW:
		S_LocalSound ("misc/menu1.wav");
		vid_line++;

		if (vid_line >= vid_wmodes)
			vid_line = 0;
		break;

	case K_LEFTARROW:
		S_LocalSound ("misc/menu1.wav");
		vid_line -= vid_column_size;

		if (vid_line < 0)
		{
			vid_line += ((vid_wmodes + (vid_column_size - 1)) /
					vid_column_size) * vid_column_size;

			while (vid_line >= vid_wmodes)
				vid_line -= vid_column_size;
		}
		break;

	case K_RIGHTARROW:
		S_LocalSound ("misc/menu1.wav");
		vid_line += vid_column_size;

		if (vid_line >= vid_wmodes)
		{
			vid_line -= ((vid_wmodes + (vid_column_size - 1)) /
					vid_column_size) * vid_column_size;

			while (vid_line < 0)
				vid_line += vid_column_size;
		}
		break;
	case K_CTRL:
	case K_ENTER:
		S_LocalSound ("misc/menu1.wav");
		VID_SetMode (modedescs[vid_line].modenum, NULL/*vid_current_palette*/);
		break;
	default:
		break;
	}
}

/*
================
VID_ModeInfo
================
*/
char *VID_ModeInfo (int modenum, char **ppheader)
{
	static char	*badmodestr = "Bad mode number";
	vmode_t		*pv;

	pv = VID_GetModePtr (modenum);

	if (!pv)
	{
		if (ppheader)
			*ppheader = NULL;
		return badmodestr;
	}
	else
	{
		if (ppheader)
			*ppheader = pv->header;
		return pv->name;
	}
}
