#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

#include "peninputmgr.h"

//#include "AppRsc.h"
//#include "App_Cst.h"

#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif

#include "YDKmenu.h"

#include "PNOMain.h"

extern char os9x_curVolume;

#define SCREEN_W  320
#define SCREEN_H  320



WinHandle ydk_winh=NULL,ydk_offwinh=NULL;
UInt8 *ydk_WinScreenLock(int mode)
{
	UInt8 *result=NULL;
	UInt32  maxP,freeP;	
	MemHeapFreeBytes(0,&freeP,&maxP);				
	if ((ydk_offwinh)||(maxP<500*1024)) return NULL; //already locked
	ydk_winh=WinGetDrawWindow();	
	if (ydk_winh)
	{
	    BitmapType *winb;
	    UInt32 _pitch,_height,_width;
	    UInt16 _error;
		ydk_offwinh = WinCreateOffscreenWindow(display_pitch>>1,display_height,nativeFormat, &_error);
		if (!_error)
		{
			if (mode==winLockCopy)
			{
				RectangleType srcRect;
				srcRect.topLeft.x=0;srcRect.topLeft.y=0;
				srcRect.extent.x=display_pitch>>1;srcRect.extent.y=display_height;
				WinCopyRectangle (ydk_winh,ydk_offwinh,&srcRect,0,0,winPaint);
			}
			WinSetDrawWindow(ydk_offwinh);
			winb = WinGetBitmap ( ydk_offwinh );
			result=(UInt8*)BmpGetBits ( winb );
		} else ydk_offwinh=NULL;
	}	
	return result;
}

void ydk_WinScreenUnlock(void)
{
	if (ydk_offwinh)
	{
		BitmapType *winb;
		RectangleType srcRect;
		srcRect.topLeft.x=0;srcRect.topLeft.y=0;
		srcRect.extent.x=display_pitch>>1;srcRect.extent.y=display_height;
		WinCopyRectangle (ydk_offwinh,ydk_winh,&srcRect,0,0,winPaint);
		WinSetDrawWindow(ydk_winh);
		WinDeleteWindow(ydk_offwinh,false);
		ydk_offwinh=NULL;
	}
}

extern char g_debugbuffer[128];
extern int g_debugbufferpos;

int menu_debug(char *message)
{
/*	FILE *f;
	char filename[64];
	strcpy(filename,"0:/ydk-debug.txt");
	filename[0]=os9x_curVolume+'0';
	f=fopen(filename,"wb");
	if (f)
	{
		char c;
		fseek(f,0,SEEK_END);
		
		fwrite(message,1,strlen(message),f);
		c='\n';
		fwrite(&c,1,1,f);
		fclose(f);
	}*/
	if (message)
	{
		int l,y,pos;
//		menu_confirm(message);
		memcpy(g_debugbuffer+g_debugbufferpos,message,strlen(message));

		g_debugbufferpos+=strlen(message);
		g_debugbuffer[g_debugbufferpos++]='.';
		g_debugbuffer[g_debugbufferpos]=0;		

		y=0;pos=0;
		for (l=(g_debugbufferpos/24)+1;l;l--)
		{
			menu_messageRaw(0,y,g_debugbuffer+pos);
			pos+=24;
			y+=18;
		}
		//PrefSetAppPreferences(APPLI_ID,FTR_PREF_CRASHINFO_ID,(short)VERSION,(void*)g_debugbuffer,(short)128,(unsigned char)0);

	}
}

int menu_confirm(char *message)
{
	RectangleType ryes,rno;
	int x,y;
	menu_message(message);
	menu_button (160-43-60,200,"Yes",2,&ryes,1);
	menu_button (160-43+60,200,"No",2,&rno,1);
	
	for (;;)
	{
		menu_waitPen(&x, &y, 1, 0);
		if (TEST_PEN_MENU(x,y,ryes)) return 1;
		if (TEST_PEN_MENU(x,y,rno)) return 0;
	}
}

void menu_info(char *message){
	RectangleType rok;
	int x,y;
	menu_messageL(message);
//	menu_button (160-43,200,"Ok",2,&rok,1);	
	for (;;)
	{
		menu_waitPen(&x, &y, 1, 1);
		return;
//		if (TEST_PEN_MENU(x,y,rok)) return ;
	}
}

int menu_confirm2(char *message)
{
	RectangleType ryes,rno;
	int x,y;
	menu_message(message);
	menu_button (160-43-60,200,"Yes",2,&ryes,1);
	menu_button (160-43+60,200,"No",2,&rno,1);
	
	for (;;)
	{
		menu_waitPen(&x, &y, 0, 0);
		if (TEST_PEN_MENU(x,y,ryes)) return 1;
		if (TEST_PEN_MENU(x,y,rno)) return 0;
	}
}



int menu_getTick(void)
{
	long long l;
	l=TimGetTicks();		
	return l*1000/SysTicksPerSecond();
}
void menu_wait(int ms)
{
	int start=menu_getTick();
	while (menu_getTick()-start<ms) ;
}


void menu_messageRaw(int X,int Y,char *message)
{
#ifdef __PACE__
	stub_menu_messageRaw(X,Y,message);
#else
	RGBColorType fg;	
	RectangleType rect;	
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
	
    FntSetFont(boldFont);
    
    width=FntCharsWidth(message,StrLen(message));        
	WinSetDrawMode(winOverlay);
    fg.r=220;fg.g=180;fg.b=40;
    WinSetTextColorRGB(&fg,NULL);    
	WinPaintChars(message,StrLen(message),X,Y);
	
	WinPopDrawState();
#endif	
}


void menu_message(char *message)
{
#ifdef __PACE__
	stub_menu_message(message);
#else
	RGBColorType fg;	
	RectangleType rect;	
	Int16 width,j;	
	Boolean notruncated;
	char *p;
	
	notruncated=1;
	p=message;
	j=StrLen(p);
	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);

    WinSetDrawMode(winPaint);
    FntSetFont(boldFont);
    
    width=FntCharsWidth(message,StrLen(message));
    
    if (width>400)
    {
	    width=400;
		FntCharsInWidth(message,&width,&j,&notruncated);
		if (!notruncated)
		{
			p=(char*)MemPtrNew(j);
			MemMove(p,message,j);
			p[j]=0;
			p[j-1]='.';p[j-2]='.';p[j-3]='.';
		}
	}
    
   	fg.r=250>>1;fg.g=250>>1;fg.b=250>>1;
    WinSetForeColorRGB(&fg,NULL);                
    rect.topLeft.x=SCREEN_W/2-width/2-5;
    rect.topLeft.y=SCREEN_H/2-FntBaseLine()/2-7;
    rect.extent.x=width+10;
    rect.extent.y=FntBaseLine()+15;
    WinPaintRectangle(&rect,8);
    fg.r=250;fg.g=250;fg.b=250;  
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=SCREEN_W/2-width/2-5+1;
    rect.topLeft.y=SCREEN_H/2-FntBaseLine()/2-7+1;
    rect.extent.x=width+10-2;
    rect.extent.y=FntBaseLine()+15-2;
    WinPaintRectangle(&rect,8);		
    
	WinSetDrawMode(winOverlay);
    fg.r=220;fg.g=180;fg.b=40;
    WinSetTextColorRGB(&fg,NULL);    
	WinPaintChars(p,j,SCREEN_W/2-width/2,SCREEN_H/2-1-FntBaseLine()/2);
	
	
	if (!notruncated) MemPtrFree(p);
	
	WinPopDrawState();

#endif	
}

void menu_button (int X,int Y,char *message,int state,RectanglePtr area,int size)
{	
#ifdef __PACE__
	stub_menu_button(X,Y,message,state,area,size);
#else
	RGBColorType fg;
	RectangleType rect;
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
	
    WinSetDrawMode(winPaint);
    
    switch (size)
	{	
		case 2:width=130;break;			
		case 1:width=80;break;
		case 0:width=40;break;				
		case 3:width=30;break;				
		case 4:width=FntCharsWidth(message,StrLen(message))+12;break;				
	}	
    
    switch (state)
    {
    	case 0:fg.r=200>>1;fg.g=130>>1;fg.b=150>>1;break;
    	case 1:fg.r=128>>1;fg.g=80>>1;fg.b=0;break;
    	case 2:fg.r=255>>1;fg.g=140>>1;fg.b=0;break;
    	case 3:fg.r=80>>1;fg.g=80>>1;fg.b=80>>1;break;
    	case 4:fg.r=160>>1;fg.g=120>>1;fg.b=205>>1;break;
    	case 5:fg.r=240>>1;fg.g=50>>1;fg.b=45>>1;break;
    	case 6:fg.r=35>>1;fg.g=210>>1;fg.b=15>>1;break;
    	case 7:fg.r=220>>1;fg.g=80>>1;fg.b=80>>1;break;
    	case 8:fg.r=30>>1;fg.g=20>>1;fg.b=220>>1;break;
    	case 9:fg.r=255>>1;fg.g=240>>1;fg.b=220>>1;break;
    }
    WinSetForeColorRGB(&fg,NULL);
                
    rect.topLeft.x=X;
    rect.topLeft.y=Y;
    rect.extent.x=/*FntCharsWidth(message,strlen(message))*/width+6;
    rect.extent.y=FntBaseLine()+12;
    if (area) *area=rect;
    WinPaintRectangle(&rect,8);
     switch (state)
    {
    	case 0:fg.r=170;fg.g=100;fg.b=140;break;
    	case 1:fg.r=128;fg.g=80;fg.b=0;break;
    	case 2:fg.r=255;fg.g=140;fg.b=0;break;
    	case 3:fg.r=80;fg.g=80;fg.b=80;break;
    	case 4:fg.r=160;fg.g=120;fg.b=205;break;
    	case 5:fg.r=240;fg.g=50;fg.b=45;break;
    	case 6:fg.r=35;fg.g=210;fg.b=15;break;
    	case 7:fg.r=220;fg.g=80;fg.b=80;break;
    	case 8:fg.r=30;fg.g=20;fg.b=220;break;
    	case 9:fg.r=255;fg.g=240;fg.b=220;break;
    }
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+1;
    rect.topLeft.y=Y+1;
    rect.extent.x=/*FntCharsWidth(message,strlen(message))*/width+6-2;
    rect.extent.y=FntBaseLine()+12-2;
    WinPaintRectangle(&rect,8);
		  
    WinSetDrawMode(winOverlay);
    switch (state)
    {    	
    	case 1:
    	case 2:
    	case 3:
    	case 5:
    	case 9:
	    fg.r=32;fg.g=32;fg.b=64;
	    break;
	    case 0:
	    case 4:
	    case 6:
	    case 7:
	    case 8:
	    
	    fg.r=255;fg.g=255;fg.b=255;
	    break;
	}
    WinSetTextColorRGB(&fg,NULL);
	WinPaintChars(message,StrLen(message),X+(width+6-FntCharsWidth(message,StrLen(message)))/2,Y+4);
	
	WinPopDrawState();
#endif	
}

void menu_bar(int X,int Y,int val,int max,RectangleType *area)
{
#ifdef __PACE__
	stub_menu_bar(X,Y,val,max,area);
#else
	RGBColorType fg;
	RectangleType rect;
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
	
    WinSetDrawMode(winPaint);
    
   	fg.r=255>>1;fg.g=250>>1;fg.b=245>>1;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X;
    rect.topLeft.y=Y+10-3;
    rect.extent.x=100+5;
    rect.extent.y=5;
    WinPaintRectangle(&rect,0);
    
    fg.r=255;fg.g=250;fg.b=245;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+1;
    rect.topLeft.y=Y+10-3+1;
    rect.extent.x=100+5-2;
    rect.extent.y=5-2;
    WinPaintRectangle(&rect,0);
    
    fg.r=250>>1;fg.g=200>>1;fg.b=255>>1;
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+val*100/max;
    rect.topLeft.y=Y-1;
    rect.extent.x=8;
    rect.extent.y=21;
    WinPaintRectangle(&rect,8);
    
    fg.r=250;fg.g=200;fg.b=255;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+val*100/max+1;
    rect.topLeft.y=Y;
    rect.extent.x=8-2;
    rect.extent.y=21-2;
    WinPaintRectangle(&rect,8);
    
    rect.topLeft.x=X;    
    rect.topLeft.y=Y;
    rect.extent.x=100+5;
    rect.extent.y=21;
    if (area) 
    {
   		if (rect.topLeft.x>=10) rect.topLeft.x-=10;
	  	else rect.topLeft.x=0;
		rect.extent.x+=20;
    	*area=rect;
	}    
	WinPopDrawState();
#endif	
}


int menu_waitPen(int *X, int *Y, int wait_release, int button_too)
{
	Int16 penX,penY,result;
	Boolean penDown;
	result=0;
		   	
   	if (wait_release==3)
   	{
		EvtGetPen(&penX, &penY, &penDown);
		if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;						
		return result;
   	}
   	
    if (wait_release)
	do{
   		EvtGetPen(&penX, &penY, &penDown);
	    if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;
		if (button_too && (KeyCurrentState() != 0))
			continue;
    } while (penDown);

    if (wait_release==2) 
    {
    	return result;
    }
    
    KeySetMask(keyBitsAll);
    
	do{
    	EvtGetPen(&penX, &penY, &penDown);
    	if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;
		if (!penDown) YDK_HANDLE_EVENT_NOFUNC()
		if (button_too && (KeyCurrentState() != 0))
		{
			while (KeyCurrentState() != 0)
			{
				SysTaskDelay(10);
			}
			KeySetMask(~keyBitsAll);
			return result;
		}
	} while (!penDown);
	
	KeySetMask(~keyBitsAll);
		
	if (wait_release)
    do{
   		EvtGetPen(&penX, &penY, &penDown);
   		if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;	
    } while (penDown);

	return result;    
}

int get_message_line(char *message,Int16 w_max){
	Int16 width,lines,pos_trunc;
	Boolean notruncated;
	lines=1;
	while (1){
		width=FntCharsWidth(message,StrLen(message));			
		if (width<=w_max) break;
		width=w_max;
		pos_trunc=StrLen(message);
		FntCharsInWidth(message,&width,&pos_trunc,&notruncated);		
		message+=pos_trunc;
		lines++;
	}
	return lines;
}

void menu_messageL(char *message)
{
#define _WIDTH_MSG_MAX_ 310
#define _HEIGHT_MSG_MAX_ 310
	RGBColorType fg;	
	RectangleType rect;	
	Int16 width,height;	
	int lines;
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
    WinSetDrawMode(winPaint);
    FntSetFont(boldFont);
    
    lines=get_message_line(message,_WIDTH_MSG_MAX_);
    height=lines*FntBaseLine();
    
    if (lines==1) width=FntCharsWidth(message,StrLen(message));
    else width=_WIDTH_MSG_MAX_;
    
    
   	fg.r=250>>1;fg.g=250>>1;fg.b=250>>1;
    WinSetForeColorRGB(&fg,NULL);                
    rect.topLeft.x=SCREEN_W/2-width/2-5;
    rect.topLeft.y=SCREEN_H/2-height/2-7;
    rect.extent.x=width+10;
    rect.extent.y=height+15;
    WinPaintRectangle(&rect,8);
    
    fg.r=250;fg.g=250;fg.b=250;  
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=SCREEN_W/2-width/2-5+1;
    rect.topLeft.y=SCREEN_H/2-height/2-7+1;
    rect.extent.x=width+10-2;
    rect.extent.y=height+15-2;
    WinPaintRectangle(&rect,8);		
    
	WinSetDrawMode(winOverlay);
    fg.r=200;fg.g=150;fg.b=10;
    WinSetTextColorRGB(&fg,NULL);    
	
	if (lines==1) WinPaintChars(message,StrLen(message),SCREEN_W/2-width/2,SCREEN_H/2-height/2);
	else
	{
		Int16 pos_trunc,x,y;
		char str[64],finish;
		Boolean notruncated;
		lines=1;
		x=SCREEN_W/2-width/2;
		y=SCREEN_H/2-height/2;
		finish=0;
		while (!finish){
			width=FntCharsWidth(message,StrLen(message));			
			if (width>_WIDTH_MSG_MAX_) {
				width=_WIDTH_MSG_MAX_;
				pos_trunc=StrLen(message);
				FntCharsInWidth(message,&width,&pos_trunc,&notruncated);		
			} else {pos_trunc=StrLen(message);finish=1;}
			StrNCopy(str,message,pos_trunc);
			str[pos_trunc]=0;
			if ((y>=0)&&(y<_HEIGHT_MSG_MAX_)) WinPaintChars(str,StrLen(str),x,y);			
			message+=pos_trunc;
			y+=FntBaseLine();
		}
	}
	
	WinPopDrawState();
}
