/*
	File:			ydkmain68k.c	

	Description:	Contains the 68K portion of the Palm ARMlet.  It sets up a form so that
					the UI works with the Palm UI, and it calls the ARMlet.

	Author:		

	Copyright:		Copyright  2003 by Tapwave, Inc.

	Disclaimer:		IMPORTANT:  This Tapwave software is provided by Tapwave, Inc. ("Tapwave").  Your 
					use is subject to and governed by terms and conditions of the Software Development 
					Kit Agreement ("SDK Agreement") between you and Tapwave.  If you have not entered 
					into Tapwaves standard SDK Agreement with Tapwave, you have no right or license 
					to use, reproduce, modify, distribute or otherwise exploit this Tapwave software.  
					You may obtain a copy of Tapwaves standard SDK Agreement by calling 650-960-1817
					or visiting Tapwave at http://www.tapwave.com/developers/. 

	Change History (most recent first):
				
*/

//#define TESTING_ONLY

#include <PalmOS.h>
#include <VFSMgr.h>
#include <StringMgr.h>
#include <PCENativeCall.h>
#include "ydk_pnoload.h"
#include "pnobridge.h"

#include <coretraps.h>
#include <DLServer.h>

#include <SonyCLIE.h>
#include "TapWave/TwChars.h"
#include "stdfile.h"
#include "host68k.h"
#include "display68k.h"
#include "AppRsc.h"
#include "WebBrowserManager.h"

#include <TwKeys.h>


// Define the minimum OS version we support (2.0 for now).
#define kPalmOS10Version	sysMakeROMVersion(1,0,0,sysROMStageRelease,0)


#include <BtCommVdrv.h>
// Fix a bug in the Bluetooth SDK
#ifdef BtLibSdpUuidInitialize
#undef BtLibSdpUuidInitialize
#endif
#define BtLibSdpUuidInitialize(uuid, define, defineSize)  { (uuid).size = (defineSize); \
 MemMove((uuid).UUID, (define), (uuid).size); }


UInt16 n2PlayerRole = 0;
UInt16 nSerPortId = 0;
Boolean bSerPortOpened = false;

#include <NetMgr.h>
#define IGNORE_STDIO_STUBS
#include <unix/sys_socket.h>

#define INVALIDSOCKET ((NetSocketRef) -1)
#define IPPORT_USERRESERVED  5000

Boolean bNetLibOpened = false;
UInt16 netLibRefNum = 0;
NetSocketRef insocket = INVALIDSOCKET;
NetSocketRef outsocket = INVALIDSOCKET;
UInt32	gblQuakePort = 26000;


// collapsable input area
Int32 g_CollapseAPIVersion=0;
Err CollapseDisplayResizedEventCallback(SysNotifyParamType *notifyParamsP);
UInt16 SonySilkLibRefNum=0; // Sony's silk manager library
#define sonyVersion1 -1
#define sonyVersion2 -2

char bTreo600SDK = false, bTreo650SDK = false; // if it ever runs on a Treo 600, we may need to swap pixels


int g_num_entries;
char **g_listchoice;

int p_video_x,p_video_y,p_video_rot;

Boolean bKeyFound = false;
Boolean bDonate = false;
Int16 numSupportedBrowsers;

Boolean bConsoleClosed = false;

zquake_pref_t g_zquake_pref;

int gblPlayerMode = 0;
int gblDebugLog = 0;
int gblMute = 0;

// from "palm5way.h"
#define vchrNavChange           (vchrPalmMin + 3)

#define navBitsAll              0x001F
#define navChangeSelect         0x1000
#define navChangeBitsAll        0x1F00

#define IsFiveWayNavEvent(eventP)																		\
	(																												\
		 ((eventP)->data.keyDown.chr == vchrPageUp ||												\
		  (eventP)->data.keyDown.chr == vchrPageDown ||												\
		  (eventP)->data.keyDown.chr == vchrNavChange)												\
	&&																												\
		 (((eventP)->data.keyDown.keyCode & (navBitsAll | navChangeBitsAll)) != 0)			\
	)

#define NavSelectPressed(eventP)																			\
	(																												\
		IsFiveWayNavEvent(eventP)																			\
	&&																												\
		(((eventP)->data.keyDown.modifiers & autoRepeatKeyMask) == 0)							\
	&&																												\
		(((eventP)->data.keyDown.keyCode & (navBitsAll | navChangeBitsAll)) ==				\
																		 navChangeSelect)						\
	)

Err CollapseDisplayResizedEventCallback( SysNotifyParamType *notifyParamsP );
UInt32 LaunchPNO();

char device_type;
//char g_fullscreen;
//char g_portrait;
char g_launch_pno;
extern UInt32 hw_flags;
char g_consoleCmd[256];
/**********************************/

typedef struct {UInt32 val;char *label;} t_hardkey;
t_hardkey hardkeys[]={
{keyBitPower,"Power"},
{keyBitPageUp,"Pg up"},
{keyBitPageDown,"Pg down"},
{keyBitHard1,"Hard1"},
{keyBitHard2,"Hard2"},
{keyBitHard3,"Hard3"},
{keyBitHard4,"Hard4"},
{keyBitCradle,"Cradle"},
{keyBitAntenna,"Antenna"},
{keyBitContrast,"Contrast"},
{keyBitNavUp,"Nav Up"},
{keyBitNavDown,"Nav Down"},
{keyBitNavLeft,"Nav Left"},
{keyBitNavRight,"Nav Right"},
{keyBitNavSelect,"Nav Select"},
{keyBitActionA,"Action A"},
{keyBitActionB,"Action B"},
{keyBitActionC,"Action C"},
{keyBitActionD,"Action D"},
{keyBitTriggerA,"Trig Left"},
{keyBitTriggerB,"Trig Right"},
{keyBitFunction,"Function"},
{keyBitLaunch,"Launch"},
{0,""}
};


	
void garbage_collect ( void );
void LoadZippedModuleFromCard(/*UInt16 id*/char *name);
UInt32 UnzipToFtr(char *name,UInt16 Ftr);

#define SET_FRM_COLORS() { \
			RGBColorType col;\
			Int16 cr,cg,cb,cr2,cg2,cb2;\
			cr=100;cg=60;cb=10;\
			col.r=cr;col.g=cg;col.b=cb;\
			UIColorSetTableEntry(UIFormFill,&col);\
			UIColorSetTableEntry(UIDialogFill,&col);\
			UIColorSetTableEntry(UIAlertFill,&col);\
			col.r>>=1;col.g>>=1;col.b>>=1;\
			UIColorSetTableEntry(UIFormFrame,&col);\
			UIColorSetTableEntry(UIDialogFrame,&col);\
			UIColorSetTableEntry(UIAlertFrame,&col);\
			cr2=20;cg2=40;cb2=100;\
			col.r=cr2;col.g=cg2;col.b=cb2;\
			UIColorSetTableEntry(UIObjectFill,&col);\
			col.r=(cr+cr2)>>1;\
			col.g=(cg+cr2)>>1;\
			col.b=(cb+cr2)>>1;\
			UIColorSetTableEntry(UIObjectFrame,&col);\
			cr=240;cg=160;cb=240;\
			col.r=cr;col.g=cg;col.b=cb;\
			UIColorSetTableEntry(UIObjectForeground,&col); \
			}



#define ASK_FOR_UPDATE \
	{EventType my_event; \
	my_event.eType=frmUpdateEvent;\
	EvtAddEventToQueue(&my_event);}


#define DRAW_LOGO(X,Y)\
	{\
		MemHandle hRsc=NULL;\
		hRsc = DmGetResource(bitmapRsc, LOGOBMP);\
		if (hRsc)\
		{	BitmapType* bitmapP = (BitmapType*) MemHandleLock(hRsc);\
			WinPaintBitmap(bitmapP, X, Y);\
			MemHandleUnlock(hRsc);\
			DmReleaseResource(hRsc);}\
	}

void	drawList	(Int16	i,RectangleType	*bounds,Char		**items)
	{
	Char *p,q[64];	
	Int16 j=0;
	Int16 wid;
	Boolean notruncated;
	IndexedColorType selectColor = UIColorGetTableEntryIndex(UIObjectSelectedForeground);
	IndexedColorType myColor=0;
	IndexedColorType itemColor = WinSetForeColor(myColor);	
	RGBColorType fg,bg;	
	
	WinSetForeColor(itemColor);	
	if (i>=g_num_entries) return;	
	p=g_listchoice[i];
		
	while (p[j++]);
	
	WinPushDrawState();	
    WinSetDrawMode(winPaint);
    
	j--;    
	
	switch (g_listchoice[i][0])
	{
		case 3: //SLOT 2
			fg.r=100;fg.g=50;fg.b=200;
		break;
		case 2: //SLOT 1
			fg.r=120;fg.g=140;fg.b=40;
		break;
		case 1:
		default:  //SLOT 0 (internal)
			fg.r=50;fg.g=150;fg.b=70;
		break;
	}
	
	bg.r=255;bg.g=255;bg.b=255;       
	
    if (((p[j-1]=='P')||(p[j-1]=='p'))&&((p[j-2]=='I')||(p[j-2]=='i'))&&((p[j-3]=='Z')||(p[j-3]=='z')))
    {
	    //FntSetFont(boldFont);
	}
	else
	{
	    UInt16 cr=(UInt16)(fg.r)*4/3;
	    UInt16 cg=(UInt16)(fg.g)*4/3;
	    UInt16 cb=(UInt16)(fg.b)*4/3;
	    if (cr>255) cr=255;if (cg>255) cg=255;if (cb>255) cb=255;
	    fg.r=cr;fg.b=cb;fg.b=cb;
//		fg.r<<=1;fg.g<<=1;fg.b<<=1;
	}   
	
	if (itemColor == selectColor)
		{fg.r^=255;fg.g^=255;fg.b^=255;
		bg.r^=255;bg.g^=255;bg.b^=255;}
	        	
    WinSetTextColorRGB(&fg,NULL);    
//    WinSetBackColorRGB(&bg,NULL);


	wid=100;
	FntCharsInWidth(p,&wid,&j,&notruncated);
	if (!notruncated)
	{
		if (j>63) {j=63;DEBUGS("drawList => truncated string with > 63chars");}
		p=q;//(Char*)MemPtrNew(j);
		MemMove(p,g_listchoice[i],j);
		p[j]=0;
		p[j-1]='.';p[j-2]='.';p[j-3]='.';
	}
	
	
	WinSetCoordinateSystem(kCoordinatesNative);
	
	WinPaintChars(p,j,bounds->topLeft.x*2,
			bounds->topLeft.y*2);
			
	WinSetDrawMode(winOverlay);
	
	if (itemColor == selectColor)
	{
	fg.r<<=1;fg.g<<=1;fg.b<<=1;
    WinSetTextColorRGB(&fg,NULL);
	WinPaintChars(p,j,bounds->topLeft.x*2-1,
			bounds->topLeft.y*2-1);
	}		
//	if (!notruncated) MemPtrFree(p);
	WinPopDrawState();	
	}


static void DisplayNagging(int nReason)
{
	Char *tmp, string[64];
	Int16 x, y, nWaitTime = 10 + nReason;
	UInt32 width, height;
	RGBColorType fg,bg;	
	RectangleType rect;
	
	WinScreenMode(winScreenModeGet, &width, &height, NULL, NULL);

	DoNiceTransition(0);
	
	fg.r=255; fg.g=120; fg.b=10;
	bg.r=0; bg.g=0; bg.b=0;
	        	
    WinSetTextColorRGB(&fg,NULL);    
	WinSetBackColorRGB(&bg,NULL);

	y = 10;
	SysTaskDelay(10);
	tmp = "Dear User,";
	x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;
	WinDrawChars(tmp, StrLen(tmp), x, y);
	y += 20;

	SysTaskDelay(10);
	tmp = "I hope you like multiplayer ZQuake.";
	x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;
	WinDrawChars(tmp, StrLen(tmp), x, y);
	y += 12;

	SysTaskDelay(10);
	tmp = "Want to show me your gratitude?";
	x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;
	WinDrawChars(tmp, StrLen(tmp), x, y);
	y += 12;

	SysTaskDelay(10);
	tmp = "Just donate 5 US-$";
	x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;
	WinDrawChars(tmp, StrLen(tmp), x, y);
	y += 12;

	SysTaskDelay(10);
	tmp = "You will receive a key which removes";
	x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;
	WinDrawChars(tmp, StrLen(tmp), x, y);
	y += 12;
	
	SysTaskDelay(10);
	tmp = "this screen.";
	x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;
	WinDrawChars(tmp, StrLen(tmp), x, y);
	y += 20;
	
	SysTaskDelay(10);
	tmp = "Happy fragging!";
	x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;
	WinDrawChars(tmp, StrLen(tmp), x, y);
	y += 20;

	SysTaskDelay(10);
	{
		tmp = "Donate!";
		x = (width - FntCharsWidth(tmp, StrLen(tmp))) / 2;

		fg.r=250>>1; fg.g=250>>1; fg.b=250>>1;
		WinSetForeColorRGB(&fg, NULL);                
		rect.topLeft.x = x - 10;
		rect.topLeft.y = y - 3;
		rect.extent.x = FntCharsWidth(tmp, StrLen(tmp)) + 20;
		rect.extent.y = 18;
		WinDrawRectangle(&rect, 8);
		WinSetForeColorRGB(&bg, NULL);
		rect.topLeft.x = x - 9;
		rect.topLeft.y = y - 2;
		rect.extent.x = FntCharsWidth(tmp, StrLen(tmp)) + 18;
		rect.extent.y = 16;
		WinDrawRectangle(&rect, 8);		
		WinDrawChars(tmp, StrLen(tmp), x, y);
	}
	
	while (nWaitTime > 0)
	{
		Boolean down;
		int k;

		StrPrintF(string, "Continues in %02d secs.", nWaitTime);
		x = (width - FntCharsWidth(string, StrLen(string))) / 2;
		WinDrawChars(string, StrLen(string), x, height - 25);
		for (k=0; k<10; k++)
		{
			SysTaskDelay(SysTicksPerSecond() / 10);
			EvtGetPen(&x, &y, &down);
			if (down && RctPtInRectangle(x, y, &rect))
			{
				bDonate = true;
				break;
			}
		}
		if (bDonate)
			break;
		nWaitTime--;
	}

	DoNiceTransition(0);
}


void StartGame()
{
	char *ptr;
	Char strUserName[dlkUserNameBufSize]; 

	// Switch to fullscreen if choosed
	// and read current screen size
	// eventually turn on software landscape if necessary				
	if (g_zquake_pref.fullscreen)
		hw_set_FullscreenGraf(1);
	if (device_type & _ZODIAC_DEVICE_)
	{
		int res;

		if (res = tw_gfx_init())
		{
			DEBUGS("Cannot init Zodiac gfx");
			DEBUGU32(res);
			device_type &= ~_ZODIAC_DEVICE_;
		}
	}
	{
		UInt16 pitch, width, height;

    	hw_guess_screen_dimensions ( &width, &height, &pitch );			    	
    	if (g_zquake_pref.portrait)
    	{
    		p_video_x=320;
    		p_video_y=320;
    	}
    	else
    	{
	    	if (width==480)
	    	{
	    		p_video_x=480;
	    		p_video_y=320;
	    	}
	    	if (height==480)
	    	{
		    	p_video_x=480;
    			p_video_y=320;
    			p_video_rot=1;
	    	}
	    }
    }

	// nagging
	if ((gblPlayerMode > 0) && (!bKeyFound))
	{
		if (g_zquake_pref.first < 32)
			g_zquake_pref.first++;

		if (g_zquake_pref.first == 16)
		{
			DisplayNagging(10);
		}
		else if (g_zquake_pref.first == 26)
		{
			DisplayNagging(5);
		}
		else if (g_zquake_pref.first >= 32)
		{
			DisplayNagging(10);
			g_zquake_pref.first = 27;
		}
	}

	/* SAVE PREF to be sure*/
	PrefSetAppPreferences(CREATORID, 0x0001, (short)VERSION_DB, (void*)NULL, (short)0, false);
	PrefSetAppPreferences(CREATORID, 0x0001, (short)VERSION_DB, (void*)&g_zquake_pref, (short)sizeof(g_zquake_pref), false);

	if (bDonate)
	{
		if (numSupportedBrowsers > 0)
		{
			Char strURL[256];
			StrCopy(strURL, "https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=metaview%40web%2ede&item_name=Multiplayersupport%20for%20ZQuake&amount=5%2e00&no_shipping=0&no_note=1&tax=0&currency_code=USD&charset=UTF%2d8");
			if (WBM_OpenWebPage(0, strURL) == errNone)
				g_launch_pno = false;
		}
		if (g_launch_pno)
		{
			menu_inform("Please check my website to see how to donate.");
			bDonate = false;
		}

		g_zquake_pref.first = 1;
	}

	if (!bDonate)
	{
		DlkGetSyncInfo (NULL, NULL, NULL, strUserName, NULL, NULL);

		FtrSet(CREATORID, FTR_VIDEO_RESX_ID, p_video_x);
		FtrSet(CREATORID, FTR_VIDEO_RESY_ID, p_video_y);
		FtrSet(CREATORID, FTR_VIDEO_ROT_ID, p_video_rot);
		FtrSet(CREATORID, FTR_DEBUGFILE_ID, gblDebugLog);
		FtrSet(CREATORID, FTR_MUTE_ID, gblMute);
		FtrSet(CREATORID, FTR_TREO_600_ID, bTreo600SDK);
		FtrSet(CREATORID, FTR_TREO_650_ID, bTreo650SDK);

		FtrPtrNew(CREATORID, FTR_OPT_INPUTCONF_ID, 20*4, (void**)&ptr);
		DmWrite(ptr,0,(void*)&(g_zquake_pref.g_inputconf[0]),20*4);

		FtrSet(CREATORID, FTR_SER_ROLE_ID, n2PlayerRole);
		FtrSet(CREATORID, FTR_SER_PORT_ID, nSerPortId);
		FtrSet(CREATORID, FTR_SER_OPEN_ID, bSerPortOpened);

		FtrSet(CREATORID, FTR_NET_OPEN_ID, bNetLibOpened);
		FtrSet(CREATORID, FTR_NET_IP_ID, g_zquake_pref.g_ipaddress);
		FtrSet(CREATORID, FTR_NET_LIB_ID, netLibRefNum);
		FtrSet(CREATORID, FTR_NET_PORT_ID, gblQuakePort);
		FtrPtrNew(CREATORID, FTR_NET_USER_ID, dlkUserNameBufSize, (void**)&ptr);
		DmWrite(ptr, 0, strUserName, dlkUserNameBufSize);
	
		LaunchPNO();

		FtrUnregister(CREATORID, FTR_NET_OPEN_ID);
		FtrUnregister(CREATORID, FTR_NET_IP_ID);
		FtrUnregister(CREATORID, FTR_NET_LIB_ID);
		FtrUnregister(CREATORID, FTR_NET_PORT_ID);
		FtrPtrFree(CREATORID, FTR_NET_USER_ID);

		FtrUnregister(CREATORID, FTR_SER_ROLE_ID);
		FtrUnregister(CREATORID, FTR_SER_PORT_ID);
		FtrUnregister(CREATORID, FTR_SER_OPEN_ID);
		
		FtrPtrFree(CREATORID, FTR_OPT_INPUTCONF_ID);
		FtrUnregister(CREATORID, FTR_VIDEO_RESX_ID);
		FtrUnregister(CREATORID, FTR_VIDEO_RESY_ID);
		FtrUnregister(CREATORID, FTR_VIDEO_ROT_ID);
		FtrUnregister(CREATORID, FTR_DEBUGFILE_ID);
		FtrUnregister(CREATORID, FTR_MUTE_ID);
		FtrUnregister(CREATORID, FTR_TREO_600_ID);
		FtrUnregister(CREATORID, FTR_TREO_650_ID);
	}

	FtrPtrFree(CREATORID, FTR_PAK_DIR_ID);
	
	if (bSerPortOpened)
		SrmClose(nSerPortId);
	if (bNetLibOpened)
		NetLibClose(netLibRefNum, false);

	if (device_type & _ZODIAC_DEVICE_)
		tw_gfx_close();
	if (g_zquake_pref.fullscreen)
		hw_set_FullscreenGraf(0);
}


static void HandleLaunchButton(FormPtr frmP)
{
	Int16 idx;
	ListType *list;
	char *ftrptr;

	list = (ListType*) FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, FORM_LISTFILE_ID));
	idx = LstGetSelection(list);
	if ((idx >= 0) && (idx < g_num_entries))
	{
		if (!g_zquake_pref.key_defined)
		{
			menu_inform("You forgot to setup controls.");
			menu_inform("HOME won't exit the game. ");
			menu_inform("So setup controls carefully.");
			ASK_FOR_UPDATE
		}
		else
		{
			StrCopy(g_zquake_pref.g_wadfile,(g_listchoice[idx]));
			FtrPtrNew(CREATORID, FTR_PAK_DIR_ID, 256, (void **)&ftrptr);
			DmStrCopy(ftrptr, 0, g_zquake_pref.g_wadfile);							
			g_launch_pno = 1;
		}
	}
	else
	{
		menu_inform("Please select a PAK file.");
		ASK_FOR_UPDATE
	}
	
	if (!g_launch_pno)
		return;

	if (gblPlayerMode == 3)
	{
		UInt16 inetErr = 0;
		Err err = errNone;
		UInt8 allInterfacesUp;
		UInt16 netIFErr;
		UInt32 **addrp;
		NetSocketAddrINType sockAddr;

		err = NetLibOpen(netLibRefNum, &inetErr);
		if (((err != errNone) && (err != netErrAlreadyOpen)) || (inetErr != errNone))
		{
			char tmp[64];

			if (err == netErrConfigNotFound)
				StrCopy(tmp, "Network not configured.");
			else if (err == netErrNoInterfaces)
				StrCopy(tmp, "No network interface defined.");
			else if (err == netErrPrefNotFound)
				StrCopy(tmp, "Network preference not found.");
			else if (err == netErrOutOfMemory)
				StrCopy(tmp, "Not enough memory.");
			else if (err == netErrConfigAliasErr)
				StrCopy(tmp, "Configuration error.");
			else if (inetErr == netErrNoInterfaces)
				StrCopy(tmp, "No interfaces defined.");
			else if (inetErr == netErrPrefNotFound)
				StrCopy(tmp, "Settings not found.");
			else if (inetErr == netErrUserCancel)
				StrCopy(tmp, "User cancelled.");
			else
				StrPrintF(tmp, "NetLibOpen: 0x%x inetErr: 0x%x", err, inetErr);
			DEBUGS(tmp);
		}
		else
		{
			// gblIPAddress
			NetLibConnectionRefresh(netLibRefNum, true, &allInterfacesUp, &netIFErr);
			bNetLibOpened = true;
		}
	}
	else if (gblPlayerMode > 0)
	{
		SrmOpenConfigType config;
		BtVdOpenParams params;
		Err err;

		n2PlayerRole = gblPlayerMode - 1;

		if (n2PlayerRole == 0)
		{
			params.role = btVdClient;
			params.u.client.remoteDevAddr.address[0] = 0;
			params.u.client.remoteDevAddr.address[1] = 0;
			params.u.client.remoteDevAddr.address[2] = 0;
			params.u.client.remoteDevAddr.address[3] = 0;
			params.u.client.remoteDevAddr.address[4] = 0;
			params.u.client.remoteDevAddr.address[5] = 0;
			params.u.client.method = btVdUseUuidList;
			params.u.client.u.uuidList.len = 0;
		}
		else
		{
			params.role = btVdServer;
			BtLibSdpUuidInitialize(params.u.server.uuid, btLibSdpUUID_SC_SERIAL_PORT, btLibUuidSize16);
			params.u.server.name = "ZDoomZ";
		}
		params.authenticate = false;
		params.encrypt = false;

		config.baud = 57600;
		config.function = serFncUndefined;
		config.drvrDataP = &params;
		config.drvrDataSize = sizeof(params);
		config.sysReserved1 = 0;
		config.sysReserved2 = 0;

		err = SrmExtOpen(sysFileCVirtRfComm, &config, sizeof(config), &nSerPortId);
		if (err == serErrAlreadyOpen)
			DEBUGS("BT port is already open.");
		if ((err == errNone) || (err == serErrAlreadyOpen))
			bSerPortOpened = true;
		else
			DEBUGS("Couldn't open BT port.");
	}

	garbage_collect();
	FrmGotoForm(GameForm);
}


/***********************************************************************
 *
 * FUNCTION:    BlankFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "BlankForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean BlankFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) {
		case frmOpenEvent:{	
			ListType *list;
			
			
			SET_FRM_COLORS()
			FrmDrawForm(frmP);		
			
			if (!(g_zquake_pref.first))
			{
				menu_inform(WELCOME_MSG);
				g_zquake_pref.first = 1;
	   		}
			
			LstNewList((void**)&frmP,FORM_LISTFILE_ID,50,44,100,80,FntGetFont(),7,0);
			list=(ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTFILE_ID) );
			LstSetDrawFunction (list, (ListDrawDataFuncPtr) drawList);						
			InitFileList(list,g_zquake_pref.g_wadfile);			
			
			ASK_FOR_UPDATE

			handled = true;
			break;
		}
		case frmCloseEvent:{
			ListType *list= (ListType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,FORM_LISTFILE_ID) );
			Int16 idx;
			if (list) 
			{
				idx=LstGetSelection(list);
				if ((idx>=0)&&(idx<g_num_entries)){	
					StrCopy(g_zquake_pref.g_wadfile,(g_listchoice[idx]));
				}else g_zquake_pref.g_wadfile[0]=0;
			
				LstEraseList(list);
				LstSetListChoices(list,(char**)NULL,0);										
				if (g_listchoice) {
					int i;
					for (i=0;i<g_num_entries;i++)
						MemPtrFree(g_listchoice[i]);
					MemPtrFree(g_listchoice);
					g_listchoice=NULL;
				}				
				garbage_collect();
			}													
			break;
		}
		case ctlSelectEvent:
		{
			switch ( eventP->data.ctlSelect.controlID )
			{
				case LaunchBUTTON:
					HandleLaunchButton(frmP);
					handled=true;
					break;
				case ControlsBUTTON:
					FrmGotoForm(ConfigForm);
					handled=true;
					break;
				case OptionsBUTTON:
					FrmGotoForm(OptionsForm);
					handled=true;
					break;
				case InfoBUTTON:
					menu_inform("ZQuake 1.4");
					menu_inform("Quake (c) ID Software");
					menu_inform("Palm Port : YoyoFR, Skeezix, Squidge");
					menu_inform("http://yoyofr.fr.st");
					menu_inform("Enhanced : MetaView");
					menu_inform("www.metaviewsoft.de");
					ASK_FOR_UPDATE
					break;
			}
			break;
		}
		case keyDownEvent:
			if ((eventP->data.keyDown.chr == vchrRockerCenter) || NavSelectPressed(eventP))
			{
				HandleLaunchButton(frmP);
				handled = true;
			}
			break;
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:
			{//ydk_WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_LOGO(16,2)			
			
			//ydk_WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}

Boolean GameFormHandleEvent(EventType * eventP)
{
	Boolean         handled = false;
	FormType       *frmP = FrmGetActiveForm();
	UInt32          flags, pinMgrVersion;
	Err             err = errNone;

	switch (eventP->eType)
	{
		case frmOpenEvent:
			FrmDrawForm(frmP);
			handled = true;
			break;

		case winEnterEvent:
		case winDisplayChangedEvent:
			{
				if (g_CollapseAPIVersion != 0)
				{
					Coord         drawAreaHeightCoords, drawAreaWidthCoords;
					Int16         offsetCoordsX, offsetCoordsY;
					RectangleType formBounds;
					WinHandle     frmWinH;

					WinGetDisplayExtent( &drawAreaWidthCoords, &drawAreaHeightCoords );
HostTraceOutputTL(1, "Display: %d %d", drawAreaWidthCoords, drawAreaHeightCoords);

					frmWinH = FrmGetWindowHandle(frmP);
					WinGetBounds(frmWinH, &formBounds);
HostTraceOutputTL(1, "Form: %d %d %d %d", formBounds.topLeft.x, formBounds.topLeft.y, formBounds.extent.x, formBounds.extent.y);

					//for full screen windows topLeft.y is simply 0, or 1 for modal dialogs
					offsetCoordsX = drawAreaWidthCoords - formBounds.extent.x - formBounds.topLeft.x;
					offsetCoordsY = drawAreaHeightCoords - formBounds.extent.y - formBounds.topLeft.y;

					if (offsetCoordsX || offsetCoordsY)
					{
						formBounds.extent.x += offsetCoordsX;
						formBounds.extent.y += offsetCoordsY;

						// Change current draw window to match the display extent (app's drawing area)
						WinSetBounds( frmWinH, &formBounds );
					}
				}
			}
			handled = true;
			break;

		case nilEvent:
			if (g_launch_pno)
				StartGame();
			if (g_launch_pno)
			{
				// this is the end for you my friend...
				// until we can recover all memory allocated by the emulation core
				EventType newEvent;
				MemSet(&newEvent, sizeof(newEvent), 0);
				newEvent.eType = keyDownEvent;
				newEvent.data.keyDown.chr = launchChr;
				newEvent.data.keyDown.modifiers = commandKeyMask;
				EvtAddEventToQueue (&newEvent);
			}
			handled = true;
			break;
	}
}

void ConfigFrmUpdateControls(FormType *frmP){
	Char strtmp[64],strtmp2[64];
	FieldType *field;
	UInt16	i,j,k;
	Char g_inputfld[2000];
	g_inputfld[0]=0;
	for (i=0;i<20;i++)
	{
		if (g_zquake_pref.g_inputconf[i] == BTN_TR)
			StrCopy(strtmp, "S.TopRight");
		else if (g_zquake_pref.g_inputconf[i] == BTN_TM)
			StrCopy(strtmp, "S.TopMid");
		else if (g_zquake_pref.g_inputconf[i] == BTN_TL)
			StrCopy(strtmp, "S.TopLeft");
		else if (g_zquake_pref.g_inputconf[i] == BTN_BR)
			StrCopy(strtmp, "S.BottomRight");
		else if (g_zquake_pref.g_inputconf[i] == BTN_BM)
			StrCopy(strtmp, "S.BottomMid");
		else if (g_zquake_pref.g_inputconf[i] == BTN_BL)
			StrCopy(strtmp, "S.BottomLeft");
		else if (g_zquake_pref.g_inputconf[i] == BTN_ML)
			StrCopy(strtmp ,"S.MidLeft");
		else if (g_zquake_pref.g_inputconf[i] == BTN_MR)
			StrCopy(strtmp, "S.MidRight");
		else if (g_zquake_pref.g_inputconf[i] & 0x00010000)
			StrCopy(strtmp, "RockerUp");
		else if (g_zquake_pref.g_inputconf[i] & 0x00020000)
			StrCopy(strtmp, "RockerDn");
		else if (g_zquake_pref.g_inputconf[i] & 0x00040000)
			StrCopy(strtmp, "RockerLt");
		else if (g_zquake_pref.g_inputconf[i] & 0x00080000)
			StrCopy(strtmp, "RockerRt");
		else if (g_zquake_pref.g_inputconf[i] & 0x00100000)
			StrCopy(strtmp, "RockerCt");
		else if (g_zquake_pref.g_inputconf[i] & 0x00800000)
			StrCopy(strtmp, "Launcher");
		else if (g_zquake_pref.g_inputconf[i] & 0x04000000)
			StrCopy(strtmp, "TriggerA");
		else if (g_zquake_pref.g_inputconf[i] & 0x08000000)
			StrCopy(strtmp, "TriggerB");
		else if (g_zquake_pref.g_inputconf[i] & 0x10000000)
			StrCopy(strtmp, "Blue    ");
		else if (g_zquake_pref.g_inputconf[i] & 0x20000000)
			StrCopy(strtmp, "Yellow  ");
		else if (g_zquake_pref.g_inputconf[i] & 0x40000000)
			StrCopy(strtmp, "Green   ");
		else if (g_zquake_pref.g_inputconf[i] & 0x80000000)
			StrCopy(strtmp, "Red     ");
		else if (g_zquake_pref.g_inputconf[i] & 0x00008000)
			StrCopy(strtmp, "Function");
		else if (g_zquake_pref.g_inputconf[i] & 0x01000000)
			StrCopy(strtmp, "NavLeft ");
		else if (g_zquake_pref.g_inputconf[i] & 0x02000000)
			StrCopy(strtmp, "NavRight");
		else if (g_zquake_pref.g_inputconf[i] & 0x00000002)
			StrCopy(strtmp, "PageUp  ");
		else if (g_zquake_pref.g_inputconf[i] & 0x00000004)
			StrCopy(strtmp, "PageDown");
		else if (g_zquake_pref.g_inputconf[i] & 0x00000008)
			StrCopy(strtmp, "Cal.    ");
		else if (g_zquake_pref.g_inputconf[i] & 0x00000010)
			StrCopy(strtmp, "PhoneBk ");
		else if (g_zquake_pref.g_inputconf[i] & 0x00000020)
			StrCopy(strtmp, "ToDo    ");
		else if (g_zquake_pref.g_inputconf[i] & 0x00000040)
			StrCopy(strtmp, "Memo    ");
		else if (g_zquake_pref.g_inputconf[i] == 0x00000000)
			StrCopy(strtmp, "None    ");
		else
			StrPrintF(strtmp,"%lx",g_zquake_pref.g_inputconf[i]);
		StrCat(g_inputfld,strtmp);					
		StrCat(g_inputfld,"\n");
	}
	field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
	FldSetTextPtr(field,g_inputfld);
	FldRecalculateField (field,1);
}

/***********************************************************************
 *
 * FUNCTION:    ConfigFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "ConfigForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean ConfigFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) {
		case frmOpenEvent:{	
			ListType *list;
			
			SET_FRM_COLORS()
			FrmDrawForm(frmP);		
			
			

			ConfigFrmUpdateControls(frmP);
			ASK_FOR_UPDATE

			handled = true;
			break;
		}
		case frmCloseEvent:{
			break;
		}
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case ConfFrmHOMEButton:
					FrmGotoForm(BlankForm);
					handled=true;
					break;			
				case ConfFrmASSIGNButton:{				
					ListType *list;
					UInt32 i,j,k,old_mask;
					FieldType *field;
					list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTList) );
					i=LstGetSelection(list);									
					ydk_FadeScreen();					
					menu_messageXY(0,0,80,60,"TL",0x0AC00A);
					menu_messageXY(240,0,80,60,"TR",0x0AC00A);
 					menu_messageXY(0,120,80,60,"ML",0x0AC00A);
					menu_messageXY(240,120,80,60,"MR",0x0AC00A);
					menu_messageXY(0,260,80,60,"BL",0x0AC00A);
					menu_messageXY(240,260,80,60,"BR",0x0AC00A);
					menu_messageXY(120,0,80,60,"TM",0x0AC00A);
					menu_messageXY(120,260,80,60,"BM",0x0AC00A);
					
					menu_messageXY(158-60-40,204,80,30,"Cancel",0x80600A);
					menu_messageXY(158+60-40,204,80,30,"None",0x80600A);
					menu_messageXY(16,84,288,32,"Press a button or hit screen",0xC89664);
					old_mask=KeySetMask(~keyBitsAll);	
					if (menu_waitBtn(1,0,&k)) {	
						int l;
						if (k){	
	   						g_zquake_pref.key_defined=1;	   	
							for (l=0;l<20;l++) 
								if (g_zquake_pref.g_inputconf[l]==k) g_zquake_pref.g_inputconf[l]=0;
						}
						g_zquake_pref.g_inputconf[i]=k;
						ConfigFrmUpdateControls(frmP);
					}
					KeySetMask(old_mask/*keyBitsAll*/);
					
					if (i<LstGetNumberOfItems(list)-1) i++;
					LstSetSelection(list,i);
					
					field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
					FldSetScrollPosition(field,0);				
					FldScrollField(field,LstGetTopItem(list),winDown);		
					ASK_FOR_UPDATE
				}								
			}
		}
		case penUpEvent:{
			ListType *list;		
			FieldType *field=(FieldType*) FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTButtonField) );
			FldSetScrollPosition(field,0);				
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConfFrmINPUTList) );				
			FldScrollField(field,LstGetTopItem(list),winDown);		
			ASK_FOR_UPDATE			
			break;
		}
		case lstSelectEvent:
			break;
		case winEnterEvent:
		case winDisplayChangedEvent:
		case frmUpdateEvent:
			{//ydk_WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_LOGO(16,2)
			//ydk_WinScreenUnlock();
			}
			handled=true;
			break;
	}
    
	return handled;
}

/***********************************************************************
 *
 * FUNCTION:    OptionsFormHandleEvent
 *
 * DESCRIPTION: This routine is the event handler for the "ConfigForm" of this 
 * 				application.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should be passed to
 *				FrmHandleEvent.
 *
 ***********************************************************************/
Boolean OptionsFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err			err = errNone;

	switch (eventP->eType) {
		case frmOpenEvent:{
			ListType *list;
			Char tmp[8];
			
			SET_FRM_COLORS()
			FrmDrawForm(frmP);		
			
			LstSetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ScreenList)), g_zquake_pref.portrait ? 1 : 0);
			CtlSetLabel(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ScreenTrigger)), LstGetSelectionText(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ScreenList)), LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ScreenList)))));
			LstSetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList)), gblPlayerMode);
			CtlSetLabel(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeTrigger)), LstGetSelectionText(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList)), LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList)))));
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,DEBUGLOGCHECK),gblDebugLog);
			FrmSetControlValue (frmP,FrmGetObjectIndex(frmP,MUTECHECK), gblMute);
			if (LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList))) == 3)
			{
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, DEBUGLOGCHECK));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberLabel));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberField));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Label));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Field));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Label));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Field));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Label));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Field));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Label));
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Field));
			}
			else if (LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList))) != 0)
			{
				FrmShowObject(frmP, FrmGetObjectIndex(frmP, DEBUGLOGCHECK));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberLabel));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberField));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Field));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Field));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Field));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Field));
			}
			else
			{
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, DEBUGLOGCHECK));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberLabel));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberField));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Field));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Field));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Field));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Label));
				FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Field));
			}
			StrPrintF(tmp, "%d", g_zquake_pref.g_playerid);
			FldSetSelection(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerNumberField)), 0, FldGetTextLength(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerNumberField))));
			FldInsert(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerNumberField)), tmp, StrLen(tmp));
			StrPrintF(tmp, "%ld", (g_zquake_pref.g_ipaddress >> 24) & 0xff);
			FldSetSelection(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress1Field)), 0, FldGetTextLength(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress1Field))));
			FldInsert(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress1Field)), tmp, StrLen(tmp));
			StrPrintF(tmp, "%ld", (g_zquake_pref.g_ipaddress >> 16) & 0xff);
			FldSetSelection(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress2Field)), 0, FldGetTextLength(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress2Field))));
			FldInsert(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress2Field)), tmp, StrLen(tmp));
			StrPrintF(tmp, "%ld", (g_zquake_pref.g_ipaddress >> 8) & 0xff);
			FldSetSelection(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress3Field)), 0, FldGetTextLength(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress3Field))));
			FldInsert(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress3Field)), tmp, StrLen(tmp));
			StrPrintF(tmp, "%ld", g_zquake_pref.g_ipaddress & 0xff);
			FldSetSelection(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress4Field)), 0, FldGetTextLength(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress4Field))));
			FldInsert(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress4Field)), tmp, StrLen(tmp));

			ASK_FOR_UPDATE

			handled = true;
			break;
		}
		case frmCloseEvent:{
			Char *ptr;

			g_zquake_pref.g_ipaddress = 0;
			if (LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ScreenList))) == 0)
			{
				g_zquake_pref.portrait = 0;
				g_zquake_pref.fullscreen = 1;
			}
			else
			{
				g_zquake_pref.portrait = 1;
				g_zquake_pref.fullscreen = 0;
			}
			gblPlayerMode = LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList)));
			gblDebugLog = FrmGetControlValue (frmP,FrmGetObjectIndex(frmP, DEBUGLOGCHECK));
			gblMute = FrmGetControlValue (frmP,FrmGetObjectIndex(frmP, MUTECHECK));
			ptr = FldGetTextPtr(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerNumberField)));
			if (ptr)
				g_zquake_pref.g_playerid = StrAToI(ptr);
			n2PlayerRole = g_zquake_pref.g_playerid;
			ptr = FldGetTextPtr(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress1Field)));
			if (ptr)
				g_zquake_pref.g_ipaddress |= (StrAToI(ptr) << 24);
			ptr = FldGetTextPtr(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress2Field)));
			if (ptr)
				g_zquake_pref.g_ipaddress |= (StrAToI(ptr) << 16);
			ptr = FldGetTextPtr(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress3Field)));
			if (ptr)
				g_zquake_pref.g_ipaddress |= (StrAToI(ptr) << 8);
			ptr = FldGetTextPtr(FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, IPAddress4Field)));
			if (ptr)
				g_zquake_pref.g_ipaddress |= StrAToI(ptr);
			break;
		}
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case ConfFrmHOMEButton:
					FrmGotoForm(BlankForm);
					handled=true;
					break;
				case InfoBUTTON:
					FrmHelp(helpID_options);
					ASK_FOR_UPDATE
					handled=true;
					break;
			}
		}
		case popSelectEvent:
		{
			if (eventP->data.popSelect.controlID == PlayerModeTrigger)
			{
				if (LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList))) == 3)
				{
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, DEBUGLOGCHECK));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberLabel));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberField));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Label));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Field));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Label));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Field));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Label));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Field));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Label));
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Field));
				}
				else if (LstGetSelection (FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, PlayerModeList))) != 0)
				{
					FrmShowObject(frmP, FrmGetObjectIndex(frmP, DEBUGLOGCHECK));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberLabel));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberField));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Field));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Field));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Field));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Field));
				}
				else
				{
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, DEBUGLOGCHECK));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberLabel));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, PlayerNumberField));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress1Field));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress2Field));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress3Field));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Label));
					FrmHideObject(frmP, FrmGetObjectIndex(frmP, IPAddress4Field));
				}
			}
			break;
		}
		case keyDownEvent:
			if ((eventP->data.keyDown.chr == vchrRockerCenter) || NavSelectPressed(eventP))
			{
				FrmGotoForm(BlankForm);
				handled = true;
			}
			break;
		case winEnterEvent:	
		case winDisplayChangedEvent:	
		case frmUpdateEvent:
			{//ydk_WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			DRAW_LOGO(16,2)			

			
			//ydk_WinScreenUnlock();
			}			
			handled=true;
			break;
			
		
	}
    
	return handled;
}

Boolean ConsoleFormHandleEvent(EventType * eventP)
{
	Boolean 		handled = false;
	FormType* 		frmP = FrmGetActiveForm();
	UInt32 			flags, pinMgrVersion;
	Err				err = errNone;
//	static int		frmloaded=0;
	

	switch (eventP->eType) {
		ListType *list;
		case frmOpenEvent:{						
			SET_FRM_COLORS()
			FrmDrawForm(frmP);
			FrmSetFocus(frmP,FrmGetObjectIndex(frmP,ConsoleDataField));
			g_consoleCmd[0]=0;
			
/*			if (g_cur_ggeniecode>=0){
				FldInsert((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDescriptionField)),
					g_ggenie_list[g_cur_ggeniecode].description,
					StrLen(g_ggenie_list[g_cur_ggeniecode].description));
				FldInsert((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,GGenieCodeDataField)),
					g_ggenie_list[g_cur_ggeniecode].code,
					StrLen(g_ggenie_list[g_cur_ggeniecode].code));
			}*/
			
			ASK_FOR_UPDATE	
			handled = true;
			break;
		}
		case frmCloseEvent:							
			break;
		case ctlSelectEvent:{
			switch ( eventP->data.ctlSelect.controlID ) {			
				case ConsoleOKButton:{
						char *data;
						data=FldGetTextPtr((FieldType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,ConsoleDataField)));
						if (data){							
							//FrmGotoForm(BlankForm);
							StrCopy(g_consoleCmd,data);
							g_launch_pno=1;
							bConsoleClosed = true;
						}else {
							menu_inform("Please type something");
							ASK_FOR_UPDATE
						}
					}					
					handled=true;
					break;
				case ConsoleCancelButton:
					//FrmGotoForm(BlankForm);
					g_consoleCmd[0]=0;
					g_launch_pno=1;
					bConsoleClosed = true;
					handled=true;
					break;	
			}
			break;			
		}
		case winEnterEvent:	
		case winDisplayChangedEvent:	
//			SysSetOrientation(sysOrientationLandscape);
//			PINSetInputAreaState(pinInputAreaClosed);
		case frmUpdateEvent:		
			{UInt8 *scr=WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (scr) WinScreenUnlock();
			}
			handled=true;
			break;
	}
	return handled;
}


/***********************************************************************
 *
 * FUNCTION:    AppHandleEvent
 *
 * DESCRIPTION: This routine loads form resources and set the event
 * 				handler for the form loaded.
 *
 * PARAMETERS:  eventP - A pointer to the EventType structure.
 *
 * RETURNED:    true if the event was handled and should not be passed
 *				to a higher level handler.
 *
 ***********************************************************************/
Boolean AppHandleEvent(EventType* eventP)
{
	UInt16 formId;
	FormType * frmP= FrmGetActiveForm();
	WinHandle formWinH;
	
	if (eventP->eType == frmLoadEvent)
	{
		/* Load the form resource. */
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);
		formWinH = FrmGetWindowHandle(frmP);
		if (formId == GameForm)
		{
			if (g_CollapseAPIVersion > 0)
			{
				WinSetConstraintsSize(formWinH, 80, 160, 240, 160, 160, 240);
				FrmSetDIAPolicyAttr(frmP, frmDIAPolicyCustom);
				PINSetInputTriggerState(pinInputTriggerDisabled);
				PINSetInputAreaState(pinInputAreaClosed);
				hw_set_FullscreenGraf(1);
			}
			else if (g_CollapseAPIVersion < 0)
			{
				SilkLibEnableResize(SonySilkLibRefNum);
				SilkLibResizeDispWin(SonySilkLibRefNum, silkResizeToStatus);
				if (g_CollapseAPIVersion == sonyVersion2)
				{
					VskSetState(SonySilkLibRefNum, vskStateEnable, (vskResizeVertically|vskResizeHorizontally));
					VskSetState(SonySilkLibRefNum, vskStateResize, vskResizeMin);
					VskSetState(SonySilkLibRefNum, vskStateEnable, 0);
				}
			}
		}
		else
		{
			if (g_CollapseAPIVersion > 0)
			{
				WinSetConstraintsSize(formWinH, 160, 160, 160, 160, 160, 160);
				FrmSetDIAPolicyAttr(frmP, frmDIAPolicyStayOpen);
				PINSetInputTriggerState(pinInputTriggerDisabled);
				PINSetInputAreaState(pinInputAreaOpen);
				hw_set_FullscreenGraf(0);
			}
			else if (g_CollapseAPIVersion < 0)
			{
				SilkLibEnableResize(SonySilkLibRefNum);
				SilkLibResizeDispWin(SonySilkLibRefNum, silkResizeNormal);
				SilkLibDisableResize(SonySilkLibRefNum);
				if (g_CollapseAPIVersion == sonyVersion2)
				{
					VskSetState(SonySilkLibRefNum, vskStateEnable, (vskResizeVertically|vskResizeHorizontally));
					VskSetState(SonySilkLibRefNum, vskStateResize, vskResizeMax);
					VskSetState(SonySilkLibRefNum, vskStateEnable, 0);
				}
			}
		}

		/* 
		 * Set the event handler for the form.  The handler of the
		 * currently active form is called by FrmHandleEvent each
		 * time is receives an event. 
		 */
		switch (formId)
		{
			case BlankForm:
				FrmSetEventHandler( frmP, BlankFormHandleEvent );
				break;
			case ConfigForm:
				FrmSetEventHandler( frmP, ConfigFormHandleEvent );
				break;
			case ConsoleForm:
				FrmSetEventHandler( frmP, ConsoleFormHandleEvent );
				break;
			case OptionsForm:
				FrmSetEventHandler( frmP, OptionsFormHandleEvent );
				break;
			case GameForm:
				FrmSetEventHandler( frmP, GameFormHandleEvent );
				break;
		}
		return true;
	}		
	return false;
}


void AppEventLoop(void)
{
	UInt16 error;
	EventType event;


	do 
	{
		/* change timeout if you need periodic nilEvents */
		EvtGetEvent(&event, SysTicksPerSecond()/2);				

		if (! SysHandleEvent(&event))
		{
			if (! AppHandleEvent(&event))
			{
				if (! MenuHandleEvent(0, &event, &error))
				{
					FrmDispatchEvent(&event);
				}	
			}		
		}
		if (bConsoleClosed)
			break;
	} while (event.eType != appStopEvent);
}

void AppStop(void)
{
/*SAVE PREF*/
	PrefSetAppPreferences(CREATORID, 0x0001, (short)VERSION_DB, (void*)NULL, (short)0, false);
	PrefSetAppPreferences(CREATORID, 0x0001, (short)VERSION_DB, (void*)&g_zquake_pref, (short)sizeof(g_zquake_pref), false);
	FrmCloseAllForms();
		
}

Err CollapseDisplayResizedEventCallback( SysNotifyParamType *notifyParamsP )
{
	//uniquely post back a winDisplayChangedEvent in response to the notification
	//PinMgr 1.0 only posts the notification while PinMgr 1.1 posts back. By doing it this way 
	//your code need only handle the winDisplayChangedEvent
	EventType eventToAdd;
	
	MemSet(&eventToAdd, sizeof(EventType), 0);

	eventToAdd.eType = (eventsEnum) winDisplayChangedEvent;
	
	EvtAddUniqueEventToQueue(&eventToAdd, 0, true);
}

void CheckDirs(void)
{
	UInt16 volRefNum;			
	UInt32 volIterator; 
	Err err;
	
	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
		    VFSDirCreate(volRefNum,VFSPATH);
		 }
	}
}


void InitPrefDefaultValues()
{	

}

UInt32 query_heap_free ( void ) {
  UInt16 heapid = 0;
  UInt32 max, bytes;

  MemHeapFreeBytes ( heapid, &bytes, &max );

  //DEBUGS ( "heapfree" );
  //DEBUGU32 ( bytes );

  return ( max );
}


void garbage_collect ( void ) {

  /* on failure, compact memory */
  //MemHeapCompact ( MemPtrHeapID ( true_head() ) );

//#ifdef RSRC
  MemPtr ptr=MemPtrNew(8);	
  UInt16 heap_id=MemPtrHeapID(ptr);
  MemPtrFree(ptr);
  MemHeapCompact ( heap_id );
//#endif

  return;
}


void LoadZippedModuleFromCard(/*UInt16 id*/char *name)
{	
  UInt32 processor;
  UInt32 flags = 0;
  ControlType *c;
  FormPtr frmP = FrmGetActiveForm();
  UInt8 filetype;
  Err res;
  UInt16 initDelay,old_initDelay,old_initDblDelay;
  UInt16 period,old_period;
  UInt32 old_mask;
  Boolean queueAhead,old_queueAhead;
  MemPtr pnoPtr,ptr;
  PnoDescriptor pno;
/*  char *name;  
  MemHandle memh;
  FILE *f;
  name="tmp.pno";
  memh = DmGetResource('YDKC', id);
  if (!memh) {DEBUGS("Error while accessing pno resource");return;}
  ptr = MemHandleLock(memh);
  f=fopen("tmp.pno","wb");
  if (!f) {DEBUGS("Cannot write temp pno"); return;}
  fwrite(ptr,1,MemPtrSize(ptr),f);
  fclose(f);
  MemHandleUnlock(memh);
	DmReleaseResource(memh);
  */


//  StrPrintF(name,"%1d:%s%s",palm_vfs_iter(),VFSPATH,_name);
#ifdef TESTING_ONLY	
	return;
#endif	  
  // does emu module exist?
  {
    FILE *f = fopen ( name, "r" );
    if ( ! f ) {
      DEBUGS ( "The emulation module to run this game is not present." );
      DEBUGS (name);
      return;
    }
    fclose ( f );
  }
  // clear background
/*
  {
    RectangleType r;
    IndexedColorType c;
    r.topLeft.x = 0;
    r.topLeft.y = 16;
    r.extent.x = 160;
    r.extent.y = 160 - 16;
    c = WinSetBackColor ( 0 );
    WinDrawRectangle ( &r, 0 );
    WinSetBackColor ( c );
  }
*/
  // call the PACE Native Object
  FtrGet(sysFtrCreator, sysFtrNumProcessorID, &processor);
  // rearrange memory
  garbage_collect();
  // fire up pno
  if ( sysFtrNumProcessorIsARM ( processor ) )
  {
    pnobridge_t *bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
    MemHandle mh;
    UInt8 *tmpPtr;
    UInt16 pitch, width, height;
    Err error;    

    UnzipToFtr(name,FTR_PNO);
	FtrGet(CREATORID, FTR_PNO, (void*)&pnoPtr);		

    res=ydk_PnoLoad ( &pno, pnoPtr );
    FtrPtrFree ( CREATORID, FTR_PNO ); 
    if (res) {
		DEBUGS("Error while loading PNO");
		DEBUGU32(res);
		MemPtrFree(bridge);
		return;    	
    }
    
    
    hw_guess_screen_dimensions ( &width, &height, &pitch );
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    
    bridge -> param1 = NULL;
    
    bridge -> param2 = NULL;
    bridge -> flags = (hw_flags&hf_pin_present?BF_HASPIN:0)|
    				(device_type&_ZODIAC_DEVICE_?BF_ZODIAC:0)|
    				(device_type&_HIRES_PLUS_DEVICE_?BF_HIRESPLUS:0);

	old_mask=KeySetMask(~keyBitsAll);		
	initDelay=slowestKeyDelayRate;
	period=slowestKeyPeriodRate;
	queueAhead=false;
	KeyRates(false,&old_initDelay,&old_period,&old_initDblDelay,&old_queueAhead);
	KeyRates(true,&initDelay,&period,&initDelay,&queueAhead);
	//read memory to flush D cache
	FLUSH_D_CACHE	
//	FtrSet(CREATORID, FTR_OPT_SHOWFRAMERATE_ID,g_ljp_pref.g_showFramerate);		




    res = ydk_PnoCall ( &pno, bridge );        
//    FtrUnregister(CREATORID, FTR_OPT_SHOWFRAMERATE_ID);
	//free sys event
	{
		EventType myevent;
		for (;;)
		{
			EvtGetEvent(&myevent,0);
			if (myevent.eType==nilEvent) break;
			//SysHandleEvent(&myevent);
		}
	}
	KeySetMask(old_mask/*keyBitsAll*/);
	KeyRates(true,&old_initDelay,&old_period,&old_initDblDelay,&old_queueAhead);
	
	//unload pno
	res=ydk_PnoUnload ( &pno );
    if (res) {DEBUGS("Error while loading PNO, probably not enough free ram.");DEBUGS(name);}
    MemPtrFree(bridge);
    
//    remove("tmp.pno");
   // rearrange memory
    garbage_collect();
  } // is arm and rom picked
}

UInt32 UnzipToFtr(char *name,UInt16 Ftr){
	MemHandle memh;
	MemPtr ptr;
	PnoDescriptor pno;
	UInt32 res;
	pnobridge_t *bridge;	
	UInt16 pitch, width, height;
	
	memh = DmGetResource('YDKC', PNO_ZLIB);
	if (!memh) {DEBUGS("Error while accessing zlib resource");return 1;}
	ptr = MemHandleLock(memh);
	if (!ptr){DEBUGS("Error while locking zlib resource");return 2;}	
	res=ydk_PnoLoad ( &pno, ptr );
    FtrPtrFree ( CREATORID, FTR_PNO ); 
    if (res) {DEBUGS("Error while loading zlib pno");return 3;}
	//read memory to flush D cache
	FLUSH_D_CACHE

    bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
    hw_guess_screen_dimensions ( &width, &height, &pitch );
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    bridge -> param1 = (unsigned long)name;
    bridge -> param2 = (unsigned long)Ftr;
    bridge -> flags = BF_UNZIP;
    
    if (res=ydk_PnoCall ( &pno, bridge )) {DEBUGS("Error while unzipping");DEBUGU32(res);return 4;}
    MemPtrFree(bridge);
	//unload pno
	res=ydk_PnoUnload ( &pno );    		
    if (res) {DEBUGS("Error while loading PNO(ZIP), probably not enough free ram.");}
   // rearrange memory
	garbage_collect();
	 		
	MemHandleUnlock(memh);
	DmReleaseResource(memh);
}



UInt32 LaunchPNO()
{
	LoadZippedModuleFromCard(/*PNO_ZQUAKE*/ "zquake.zdk");
	return 0;								
}

UInt32 AppMain(void)
{
	UInt32 res = errNone;
	UInt16 pitch, width, height;
	UInt16 devErr, compErr, error;
	UInt32 deviceID, companyID, version;
	UInt16 cardNo;
	LocalID dbID;
	unsigned short val;
	char c;
	
	if ( ! hw_set16bpp() )
	{
		DEBUGS ( "Couldn't set to 16 bit colour!" );
		return res;
	}
   		   		
	SysLibFind("Net.lib", &netLibRefNum);

	// check for Treo 600 to use HS extensions
	devErr = FtrGet(sysFtrCreator, sysFtrNumOEMDeviceID, &deviceID);
	compErr = FtrGet(sysFtrCreator, sysFtrNumOEMCompanyID, &companyID);
	if ((devErr == errNone) && (compErr == errNone))
	{
		if ((deviceID == 'H201') || (deviceID == 'H101'))
			bTreo600SDK = true;
		if ((deviceID == 'H202') || (deviceID == 'H102'))
			bTreo650SDK = true;
	}
	
	if (DmFindDatabase(0, "ZQuakeKey_ZQKE") != 0)
		bKeyFound = true;

	g_launch_pno=0;
	p_video_x=p_video_y=320;
	p_video_rot=0;
	device_type=0;
	g_zquake_pref.fullscreen=0;
	g_zquake_pref.portrait=0;
	{
		UInt16 pitch, width, height;
    	hw_guess_screen_dimensions ( &width, &height, &pitch );
    	if (hw_flags & hf_pin_present)
    	{
    		device_type=_HIRES_PLUS_DEVICE_;
    	}
    }
    if (is_zodiac()) {device_type|=_ZODIAC_DEVICE_;g_zquake_pref.fullscreen=1;}
	if (is_clie()) device_type|=_CLIE_DEVICE_;

	/*Setup dir if necessary*/
	CheckDirs();
	/*Register file type for emu module*/
	VFSUnregisterDefaultDirectory ( ".zdk", expMediaType_Any);
    VFSRegisterDefaultDirectory ( ".zdk", expMediaType_Any, VFSPATH );

	/* DEFAULT PREF */
	InitPrefDefaultValues();
	
	/* LOAD PREF IF AVAILABLE WITH GOOD VERSION NUMBER*/
	// convert from saved prefs to unsaved prefs
	val = 1;
	if (PrefGetAppPreferences(CREATORID, 0x0001, (void*)&c, (unsigned short*)&val, true) != noPreferenceFound)
	{
		val = sizeof(g_zquake_pref);
		PrefGetAppPreferences(CREATORID, 0x0001, (void*)&g_zquake_pref, (unsigned short*)&val, true);
		PrefSetAppPreferences(CREATORID, 0x0001, (short)VERSION_DB, (void*)NULL, (short)0, true);
	}
	else
	{
		val = 1;
		if (PrefGetAppPreferences(CREATORID, 0x0001, (void*)&c, (unsigned short*)&val, false) == VERSION_DB);
		{
			val = sizeof(g_zquake_pref);
			PrefGetAppPreferences(CREATORID, 0x0001, (void*)&g_zquake_pref, (unsigned short*)&val, false);
		}
	}
	
	/* init random seed */
	SysRandom(TimGetTicks());
	
	error = FtrGet(pinCreator, pinFtrAPIVersion, &version);
	if (!error && version)
	{
		//PINS exists
		g_CollapseAPIVersion = version;
	}
	else
	{
		if ((error = SysLibFind(sonySysLibNameSilk, &SonySilkLibRefNum)))
		{
			if (error == sysErrLibNotFound) 
			{ /* couldn't find lib */ 
				error = SysLibLoad( 'libr', sonySysFileCSilkLib, &SonySilkLibRefNum );
				g_CollapseAPIVersion = 0;
			}
		}
		if (!error ) 
		{ 
			error = FtrGet(sonySysFtrCreator, sonySysFtrNumVskVersion, &version); 

			if (error)
			{ /* Version 1 is installed only resize is available */
				if (SilkLibOpen(SonySilkLibRefNum) == errNone)
				{
//					SilkLibEnableResize(SonySilkLibRefNum);
//					SilkLibDisableResize(SonySilkLibRefNum);
					g_CollapseAPIVersion = sonyVersion1;
				}
			}
			else
			{ /* Version 2 or up is installed Some added features are available */
				if (VskOpen(SonySilkLibRefNum) == errNone)
				{
//					VskSetState(SonySilkLibRefNum, vskStateEnable, (vskResizeVertically|vskResizeHorizontally));
//					VskSetState(SonySilkLibRefNum, vskStateEnable, 0);
					g_CollapseAPIVersion = sonyVersion2;
				}
			}
		}
	}

	if (g_CollapseAPIVersion > 0)
	{
		if (SysCurAppDatabase( &cardNo, &dbID ) == errNone)
			SysNotifyRegister( cardNo, dbID, sysNotifyDisplayResizedEvent, CollapseDisplayResizedEventCallback, sysNotifyNormalPriority, NULL );
	}
	else if (g_CollapseAPIVersion < 0)
	{
		if (SysCurAppDatabase( &cardNo, &dbID ) == errNone)
			SysNotifyRegister( cardNo, dbID, sysNotifyDisplayChangeEvent, CollapseDisplayResizedEventCallback, sysNotifyNormalPriority, NULL );
	}
	
	FrmGotoForm( BlankForm );

	AppEventLoop();
	AppStop();

	return res;
}

/***********************************************************************
 *
 * FUNCTION:    RomVersionCompatible
 *
 * DESCRIPTION: This routine checks that a ROM version is meet your
 *              minimum requirement.
 *
 * PARAMETERS:  requiredVersion - minimum rom version required
 *                                (see sysFtrNumROMVersion in SystemMgr.h 
 *                                for format)
 *              launchFlags     - flags that indicate if the application 
 *                                UI is initialized.
 *
 * RETURNED:    error code or zero if rom is compatible
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;

	// See if we're on in minimum required version of the ROM or later.
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
	{
		if ((launchFlags & (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
		{
			FrmAlert (RomIncompatibleAlert);
		
			// Palm OS 1.0 will continuously relaunch this app unless we switch to 
			// another safe one.
			if (romVersion <= kPalmOS10Version)
			{
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
			}
		}
		
		return sysErrRomIncompatible;
	}

	return errNone;
}


/***********************************************************************
 *
 * FUNCTION:    PilotMain
 *
 * DESCRIPTION: This is the main entry point for the application.
 *
 * PARAMETERS:  cmd - word value specifying the launch code. 
 *              cmdPB - pointer to a structure that is associated with the launch code. 
 *              launchFlags -  word value providing extra information about the launch.
 * RETURNED:    Result of launch
 *
 * REVISION HISTORY:
 *
 *
 ***********************************************************************/
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    NativeFuncType* entry;
    UInt32 res;
	
	if (cmd == sysAppLaunchCmdNormalLaunch) 
	{	
		res=0;
		if (!RomVersionCompatible(kOurMinVersion, launchFlags)) 
		{
			WBM_Init(&numSupportedBrowsers);
			res=AppMain();		
			WBM_End();
		}
	}

	
	return res;
}
